function [apScore,precision,reccall,isTp,isFp,isMissed,gtAssignment,maxOverlaps,numOfgt,gtIdxAll,allOverlaps] = computePRCurve_Neg(classname,predictedBbs,predictedBbsTight,imageIds,groundTruthBbs,isDifficult)
    if length(groundTruthBbs) ~= length(isDifficult), error('inconsistent difficulty size.'); end
    
    gtAssignment = zeros(size(predictedBbs,1),1);
    
    % pick ground truth of current class
    ConstsDetection;
    isMissed = false(numel(groundTruthBbs),1);
    [~,classId] = ismember(classname,consts.classNames);
    isSameClass = [groundTruthBbs.classId] == classId;
    numOfgt =sum(isSameClass);
    groundTruthBbs = groundTruthBbs(isSameClass);
    isDifficult = logical(isDifficult(isSameClass));

    P = size(predictedBbs,1);
    G = numel(groundTruthBbs);
    
    % sort all detections
    [~,sortIdx] = sort(predictedBbs(:,7));
    predictedBbs = predictedBbs(sortIdx,:);
    predictedBbsTight =predictedBbsTight(sortIdx);
    % threshold overlap
   
    tic;
    %allOverlaps = bb3dOverlapCloseForm(predictedBbs,groundTruthBbs);
    allOverlaps = bb3dOverlapCloseForm(predictedBbsTight,groundTruthBbs);
    toc;
    onSameImage = bsxfun(@eq,imageIds(:),[groundTruthBbs.imageNum]);
    allOverlaps(~onSameImage) = 0;
    [maxOverlaps,gtIdx] = max(allOverlaps,[],2);
    gtIdx(maxOverlaps<eps) = 0;
    gtIdxAll = gtIdx;
    isOverlapping = maxOverlaps >= consts.minOverlap;
    gtIdx(~isOverlapping) = 0;
    
    % Assign ground truth to the best matched detection
    [uniqueGtIdx,firstAssignment,~] = unique(gtIdx,'first');
    isFirstAssignment = false(P,1);
    isFirstAssignment(firstAssignment) = true;
    isFirstAssignment = isFirstAssignment & gtIdx>0;
    
    % Get GT assignment of each TP detection
    tmpGtAssignment = zeros(P,1);
    tmpGtAssignment(firstAssignment) = uniqueGtIdx;
    tmp = find(isSameClass);
    tmpGtAssignment(tmpGtAssignment>0) = tmp(tmpGtAssignment(tmpGtAssignment>0));
    gtAssignment(sortIdx) = tmpGtAssignment;
    
    
    % get unassigned ground truth bounding boxes
    tmpIsMissed = true(G,1);
    tmpIsMissed(setdiff(uniqueGtIdx,0)) = false;
    isMissed(isSameClass) = tmpIsMissed;
    
    % assign detection labels
    tp = ~isOverlapping;
    fp = ~tp;
    dc = gtIdx ~= 0 & isDifficult(max(1,gtIdx));
    tp(dc) = false;
    fp(dc) = false;
    
    isTp = false(numel(tp),1);
    isTp(sortIdx) = tp;
    isFp = false(numel(fp),1);
    isFp(sortIdx) = fp;
    
    % Compute precision/recall
    sumFp = cumsum(double(fp));
    sumTp = cumsum(double(tp));
    reccall = sumTp / sum(double(tp));
    precision = sumTp ./ (sumFp + sumTp);
%     reccall = sumFp /sum(double(fp));
%     precision = sumFp ./ (sumFp + sumTp);
    
    apScore = get_average_precision(precision, reccall);
end