function [apScore,precision,recall,bbIdx,tp] = generatePRCurve(categName,allbb3d,allTestImgIds,allBeta,groundTruthBbs)
    ConstsDetection;
    [~,classId] = ismember(categName,consts.classNames);

    % calibrate results
    if ~isempty(allBeta),
        allbb3d(:,7) = 1 ./ (1+exp(-allBeta(:,1).*(allbb3d(:,7)-allBeta(:,2))));
    end

    % sort detections according to confidence
    fprintf('sorting detections...\n');
    [~,idx] = sort(allbb3d(:,7),'descend');
    allbb3d = allbb3d(idx,:);
    allTestImgIds = allTestImgIds(idx);
    bbIdx = idx;
    
    % non-max suppression
    uniqueTestImgIds = unique(allTestImgIds);
    for i = 1:length(uniqueTestImgIds),
        idx = find(allTestImgIds == uniqueTestImgIds(i));
        pick = nmsMe_3d([allbb3d(idx,1:3),allbb3d(idx,1:3)+allbb3d(idx,4:6),allbb3d(idx,7)],0.5);
        discard = idx(setdiff(1:length(idx),pick));
        allbb3d(discard,:) = [];
        allTestImgIds(discard) = [];
        bbIdx(discard) = [];
    end
    
    % save as mat file for future analysis
    %fprintf('saving all detections to mat file...\n');save([outputpath '/all_detections.mat'],'-v6');
    
    fprintf('computing PR curve...\n');
    % pick ground truth of current class
    groundTruthBbs = groundTruthBbs([groundTruthBbs.classId] == classId);
    [apScore,precision,recall,idx,tp] = computePRCurve(categName,allbb3d,allTestImgIds,groundTruthBbs);
    bbIdx = bbIdx(idx);
end