function image = pointsToImage(points,rgb,Rtilt)
    % remove nan points
    isInvalid = sum(isnan(points),2) > 0;
    points(isInvalid,:) = [];
    rgb(isInvalid,:) = [];
    
    % project point to 2D space
    points2d = round(project3dPtsTo2d(points,Rtilt));
    points2d(:,1) = points2d(:,1) - min(points2d(:,1)) + 1;
    points2d(:,2) = points2d(:,2) - min(points2d(:,2)) + 1;
    image = 255*ones(max(points2d(:,2)),max(points2d(:,1)),3);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),1*ones(size(points2d,1),1))) = rgb(:,1);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),2*ones(size(points2d,1),1))) = rgb(:,2);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),3*ones(size(points2d,1),1))) = rgb(:,3);
end  
