function [image,depthmap] = renderPointCloud_depth(points,Rtilt,imageHeight,imageWidth)
    nPoints = size(points,1);
    image = nan(imageHeight,imageWidth);
    
    if nPoints ==0,
        image = nan(imageHeight,imageWidth,3);
        return;
    end
   
    [points2d,depth] = project3dPtsTo2d(points,Rtilt);
    idx =~isnan(sum(points2d,2));
    points2d = round(points2d(idx,:));
    depth =depth(idx);
    [~,depthInd]= sort(depth,'descend');
    points2d =points2d(depthInd,:);
    depth =depth(depthInd);
    depthmap = nan(imageHeight,imageWidth);
    isValid = points2d(:,1) >= 1 & points2d(:,1) <= size(depthmap,2) & points2d(:,2) >= 1 & points2d(:,2) <= size(depthmap,1);
    depthmap(sub2ind(size(depthmap),points2d(isValid,2),points2d(isValid,1),1*ones(sum(isValid),1))) = depth(isValid);
    
    image = getImagesc(depthmap);
end