function visualizeDetection_load_calibratefunTightBB(prevMatFile,modelImageFolder,modelFolder,pointFolder,dataFolder,...
            testIdRange,trainIdRange,modelName,nExamples,groundTruthBbs,gtLabels,outputpath,viewScale,loadPrevMat,replacePrevMat,cali,calitype,ignoremodelname)
    submit=1;
    minTestimage =550
    % create output folder
    if ~exist(outputpath,'dir'), mkdir(outputpath); mkdir([outputpath '/Model/']); end
    if exist('ignoremodelname','var')&&ignoremodelname
        categName =modelName;
        instanceName = modelName;
        instanceFolders = dir([dataFolder '/' categName '/']);
        instanceFolders = instanceFolders([instanceFolders.isdir]);
        keep = true(length(instanceFolders),1)&(~ismember({instanceFolders.name},{'.','..'}))';
        
    else
        % analyze model name
        [rIdx,rEIdx] = regexp([modelName '_'],'_r-?[.\d]+_');
        [sIdx,sEIdx] = regexp([modelName '_'],'_s-?[.\d]+_');
        [dIdx,dEIdx] = regexp([modelName '_'],'_d-?[.\d]+_');
        [tIdx,tEIdx] = regexp([modelName '_'],'_t-?[.\d]+_');
        [xIdx,xEIdx] = regexp([modelName '_'],'_x-?[.\d]+_');
        if length(rIdx) > 1 || length(sIdx) > 1 || length(dIdx) > 1 || length(tIdx) > 1 || length(xIdx) > 1, error('invalid model name'); end
        instanceNameEndIdx = length(modelName);
        if ~isempty(rIdx), instanceNameEndIdx = min(instanceNameEndIdx,rIdx-1); end
        if ~isempty(sIdx), instanceNameEndIdx = min(instanceNameEndIdx,sIdx-1); end
        if ~isempty(dIdx), instanceNameEndIdx = min(instanceNameEndIdx,dIdx-1); end
        if ~isempty(tIdx), instanceNameEndIdx = min(instanceNameEndIdx,tIdx-1); end
        if ~isempty(xIdx), instanceNameEndIdx = min(instanceNameEndIdx,xIdx-1); end
        rString = modelName(rIdx+1:rEIdx-1);
        sString = modelName(sIdx+1:sEIdx-1);
        dString = modelName(dIdx+1:dEIdx-1);
        tString = modelName(tIdx+1:tEIdx-1);
        xString = modelName(xIdx+1:xEIdx-1);
        instanceName = modelName(1:instanceNameEndIdx);
        idx = regexp(instanceName,'_(\d)');
        if ~exist('categName','var'),
        if isempty(idx)
            categName = instanceName;
            instanceString = [];
        else
            categName = instanceName(1:idx-1);
            instanceString = instanceName(idx+1:end);
        end
        end

        % find instances that matches model name
        instanceFolders = dir([dataFolder '/' categName '/']);
        instanceFolders = instanceFolders([instanceFolders.isdir]);
        keep = false(length(instanceFolders),1);
        for i = 1:length(instanceFolders),
            keep(i) = ~isempty(regexp(instanceFolders(i).name, instanceName, 'once'));
        end
    end
        
    instanceFolders = instanceFolders(keep);
    if isempty(instanceFolders), error('no matched instance found'); end

    % find views that matches model name, and load mat files
    allModelInstanceNames = cell(0,0);
    allModelViewNames = cell(0,0);
    allBb3d = [];
    allBb2d =[];
    allBb3dtight =[];
    allBb2dDraw = [];
    allTestImgIds = [];
    allInstancetNameIds = [];
    allViewNameIds = [];
    for i = 1:length(instanceFolders),
        viewFoldersCurr = dir([dataFolder '/' categName '/' instanceFolders(i).name '/']);
        viewFoldersCurr = viewFoldersCurr([viewFoldersCurr.isdir]&~ismember({viewFoldersCurr.name},{'.','..'}));
        
        % pick view folders that matches input rotation and scale      
        if exist('ignoremodelname','var')&&ignoremodelname
             keep = true(length(viewFoldersCurr),1);
        else
            keep = false(length(viewFoldersCurr),1);
            parfor j = 1:length(viewFoldersCurr),
                nameToMatch = [viewFoldersCurr(j).name '_'];
                keep(j) = ~isempty(regexp(nameToMatch, instanceName, 'once'));
                keep(j) = keep(j) && (isempty(rString) || ~isempty(regexp(nameToMatch, ['_' rString '_'], 'once')));
                keep(j) = keep(j) && (isempty(sString) || ~isempty(regexp(nameToMatch, ['_' sString '_'], 'once')));
                keep(j) = keep(j) && (isempty(dString) || ~isempty(regexp(nameToMatch, ['_' dString '_'], 'once')));
                keep(j) = keep(j) && (isempty(tString) || ~isempty(regexp(nameToMatch, ['_' tString '_'], 'once')));
                keep(j) = keep(j) && (isempty(xString) || ~isempty(regexp(nameToMatch, ['_' xString '_'], 'once')));
            end
        end
        viewFoldersCurr = viewFoldersCurr(keep);

        % load mat files
        allModelInstanceNamesIdOff = length(allModelInstanceNames);
        allModelViewNamesIdOff = length(allModelViewNames);
        jcnt =0;
        for j = 1:length(viewFoldersCurr),
            modelFileCurr =([modelFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '.mat']);
            skip =0;
%             skip = strcmp(categName,'sofa')&&...
%                 (~exist(['/n/fs/modelnet/TrainedModels/sofaratio1enlargefloor0.1tril-1tree0kernel0selfoccweigth1occ_0occNonlinear_0care_1en0.1fea_pointtsdfnormalshapemaxplane_2minplane_0floatCode1/' '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '.mat'],'file')||...
%                 ~exist(['/n/fs/modelnet/TrainedModels/sofaratio1.5enlargefloor0.1tril-1tree0kernel0selfoccweigth1occ_0occNonlinear_0care_1en0.1fea_pointtsdfnormalshapemaxplane_2minplane_0floatCode1/' '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '.mat'],'file')...
%                 )
            
            try 
                load(modelFileCurr),
            catch 
                skip =1;
            end
            if skip, continue;end
            jcnt =jcnt+1;
            allModelInstanceNames = [allModelInstanceNames; {instanceFolders(i).name}];
            allModelViewNames = [allModelViewNames; {viewFoldersCurr(j).name}];
            prevViewMat = [dataFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '/viewTest.mat'];

            loadPrevMattest =1;            
            if exist(prevViewMat,'file')&&loadPrevMat,
                fprintf('importing results of %s...\n',viewFoldersCurr(j).name);
                try
                prevResults = load(prevViewMat);
                idx = ismember([prevResults.allTestImgIdsview],testIdRange);                
                allBb3dview = prevResults.allBb3dview(idx,:);
                allBb2dview = prevResults.allBb2dview(idx,:);
                allBb2dDrawview = prevResults.allBb2dDrawview(idx,:);
                allBb3dtightview =prevResults.allBb3dtightview(idx,:);
                allTestImgIdsview = prevResults.allTestImgIdsview(idx,:);
                allInstancetNameIdsview ={repmat(allModelInstanceNamesIdOff+jcnt,[size(prevResults.allBb3dview(idx,:),1) 1])};
                allInstancetNameIdsview =cat(1,allInstancetNameIdsview{:});
                allViewNameIdsview = {repmat(allModelViewNamesIdOff+jcnt,[size(prevResults.allBb3dview(idx,:),1) 1])};
                allViewNameIdsview =cat(1,allViewNameIdsview{:});
                catch
                   loadPrevMattest =0;
                end

            end
            
            if ~loadPrevMattest||~exist(prevViewMat,'file')||~loadPrevMat
                fprintf('loading results of %s...\n',viewFoldersCurr(j).name);
                matFiles = dir([dataFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '/*.mat']);
                minTestimage =max(minTestimage,length(matFiles)-20)
                if length(matFiles)<minTestimage,
                   fprintf('Not enough result ! %s \n',prevViewMat);
                   continue;
                end
                allBb3dview = cell(length(matFiles),1);
                allBb2dview = cell(length(matFiles),1); 
                allBb2dDrawview = cell(length(matFiles),1);
                allBb3dtightview = cell(length(matFiles),1);
                allTestImgIdsview = cell(length(matFiles),1);
                allInstancetNameIdsview = cell(length(matFiles),1);
                allViewNameIdsview = cell(length(matFiles),1);
                NotTestImage =cell(length(matFiles),1);
                parfor k = 1:length(matFiles),
                    % parse mat file name
                    tmp = regexp(matFiles(k).name,'-','split');
                    testImgIdCurr = str2double(tmp{1}(5:end));
                    if isnan(testImgIdCurr),continue;end
                    % load mat file
                    try
                        tmp = load([dataFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '/' matFiles(k).name]);
                        bb3dCurr =tmp.result.bb3d(:,1:7);
                        bb2dDrawCurr = tmp.result.bb2dDraw;
                        bb3dtightCurr =tmp.result.bbtight3d;
                        if (size(bb3dCurr,1) ~= size(bb2dDrawCurr,1))||(size(bb3dCurr,1) ~=size(bb3dtightCurr,1)),
                            fprintf('\tInconsistent 2d and 3d bb size in %s!skipping this file...\n',matFiles(k).name);
                            continue;
                        end
                        allBb3dview(k) = {bb3dCurr};
                        allBb2dview(k) = {tmp.result.bb2d};
                        allBb2dDrawview(k) = {bb2dDrawCurr};
                        allBb3dtightview(k) ={bb3dtightCurr};
                        allTestImgIdsview(k) = {repmat(testImgIdCurr,[size(bb3dCurr,1) 1])};
                        allInstancetNameIdsview(k) = {repmat(allModelInstanceNamesIdOff+jcnt,[size(bb3dCurr,1) 1])};
                        allViewNameIdsview(k) = {repmat(allModelViewNamesIdOff+jcnt,[size(bb3dCurr,1) 1])};
                        NotTestImage(k) = {repmat(isempty(find(testIdRange == testImgIdCurr,1)),[size(bb3dCurr,1) 1])};
                    catch
                        fprintf('Could not load: %s \n',[dataFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '/' matFiles(k).name])
                    end
                end
                allBb3dview =cat(1,allBb3dview{:});
                allBb2dview = cat(1,allBb2dview{:});
                allBb2dDrawview =cat(1,allBb2dDrawview{:});
                allBb3dtightview =cat(1,allBb3dtightview{:});
                allTestImgIdsview =cat(1,allTestImgIdsview{:});
                allInstancetNameIdsview =cat(1,allInstancetNameIdsview{:});
                allViewNameIdsview =cat(1,allViewNameIdsview{:});

                save([dataFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '/viewTest.mat'],...
                    'allBb2dview','allBb3dview','allBb2dDrawview','allBb3dtightview','allTestImgIdsview','allInstancetNameIdsview','allViewNameIdsview')
 %}
               NotTestImage =cat(1,NotTestImage{:});
                NotTestImage =NotTestImage>0;
                allBb3dview(NotTestImage>0,:) =[];
                allBb2dview(NotTestImage>0,:) =[];
                allBb2dDrawview(NotTestImage,:) =[];
                allBb3dtightview(NotTestImage,:) =[];
                allTestImgIdsview(NotTestImage,:) =[];
                allInstancetNameIdsview(NotTestImage,:) =[];
                allViewNameIdsview(NotTestImage,:) =[];
            end
            
            % get califunction for this model
            modelFileCurr =([modelFolder '/' categName '/' instanceFolders(i).name '/' viewFoldersCurr(j).name '.mat']);
            califun = getCalifunction(dataFolder,modelFileCurr,testIdRange,trainIdRange,viewFoldersCurr(j).name,groundTruthBbs,gtLabels,outputpath,calitype,loadPrevMat);            

            if  ~strcmp(calitype,'no')&&~isempty(allBb3dview)
                caliscore =califun(allBb3dview(:,7));
                allBb3dview(:,7)  =caliscore;
                allBb2dDrawview(:,17) =caliscore;
                if max(caliscore(:))> 1.1, error('wornghere');end
               % [allBb3dtightview.confidence] =deal({caliscore(:)});
            end
            
            allBb3d =[allBb3d; single(allBb3dview)];
            allBb2d = [allBb2d;single(allBb2dview)];
            allBb2dDraw = [allBb2dDraw; single(allBb2dDrawview)];
            allBb3dtight =[allBb3dtight;allBb3dtightview];
            allTestImgIds = [allTestImgIds; single(allTestImgIdsview)];
            allInstancetNameIds = [allInstancetNameIds; single(allInstancetNameIdsview)];
            allViewNameIds = [allViewNameIds; single(allViewNameIdsview)];
            
        end
    end
    if isempty(allBb3d), error('no matched mat files found'); end


    % save as mat file for future analysis
    if replacePrevMat>1&&~isempty(prevMatFile)
        fprintf('saving all detections to mat file...\n');
        save([prevMatFile '.mat'],'allModelInstanceNames','allBb2d','allModelViewNames','allBb3dtight','allBb3d','allBb2dDraw','allTestImgIds','allInstancetNameIds','allViewNameIds','-v7.3');
    end
    % sort detections according to confidence
    fprintf('sorting detections...bb num: %d\n',size(allBb3d,1));
    [~,idx] = sort(allBb2dDraw(:,17),'descend');
    allBb3d = allBb3d(idx,:);
    allBb2d = allBb2d(idx,:);
    allBb2dDraw = allBb2dDraw(idx,:);
    allBb3dtight =allBb3dtight(idx,:);
    allTestImgIds = allTestImgIds(idx);
    allInstancetNameIds = allInstancetNameIds(idx);
    allViewNameIds = allViewNameIds(idx);
    % non-max suppression
    uniqueTestImgIds = unique(allTestImgIds);
    discard = false(size(allBb3d,1),1);
    parfor i = 1:length(uniqueTestImgIds),
        idx = find(allTestImgIds == uniqueTestImgIds(i));
        pick = nmsMe_3d([allBb3d(idx,1:3),allBb3d(idx,1:3)+allBb3d(idx,4:6),allBb3d(idx,7)],.25);
        %pick = nmsMe_3dtight(allBb3dtight,.25);
        discardCurr = false(size(allBb3d,1),1);
        discardCurr(idx(setdiff(1:length(idx),pick))) = true;
        discard = discard | discardCurr;
    end
    allBb3d(discard,:) = [];
    allBb2d(discard,:) = [];
    allBb2dDraw(discard,:) = [];
    allBb3dtight(discard,:) = [];
    allTestImgIds(discard) = [];
    allInstancetNameIds(discard) = [];
    allViewNameIds(discard) = [];


    
    if replacePrevMat&&~isempty(prevMatFile)
        fprintf('saving nms detections to mat file...\n');
        save([prevMatFile '_nms.mat'],'allModelInstanceNames','allBb2d','allModelViewNames','allBb3dtight','allBb3d','allBb2dDraw','allTestImgIds','allInstancetNameIds','allViewNameIds','-v7.3');
    end
    
     delete([outputpath '/*.jpg']);
     delete([outputpath '/*.png']);
    % delete([outputpath '/*.pdf']);
    % delete([outputpath '/amazing_viewer.html']);
   
%     load('load whole nms')
%     load('/n/fs/modelnet/Output/DetectionMat/chair31-Jan_testingCalisecond.mat')
    % generate PR curve

    fprintf('computing PR curve...\n');
    % pick ground truth of current class
    ConstsDetection;
    [~,classId] = ismember(categName,consts.classNames);
    isValidGt = ([groundTruthBbs.classId] == classId) & ismember([groundTruthBbs.imageNum],testIdRange);
    groundTruthBbs = groundTruthBbs(isValidGt);
    gtLabels = gtLabels(isValidGt);

%[apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurve_Neg(categName,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,gtLabels~=1);
   [apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurveTightBB(categName,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,gtLabels~=1);
    save(sprintf('%s/PRdataDifficult.mat',outputpath),'apScore','precision','recall','isTp','isFp','isMissed','gtIdx','maxOverlaps');

    f = figure('units','normalized','outerposition',[0 0 1 1],'Visible','Off');
    plot(recall, precision, '.-'); hold on;
    grid on; xlabel 'recall'; ylabel 'precision'; axis equal; axis([0,1,0,1]);
    title(sprintf('Class: %s, AP = %.3f', categName, apScore));
    saveas(f,sprintf('%s/PR_curve_difficult.png',outputpath));
    saveas(f,sprintf('%s/PR_curve_difficult.pdf',outputpath));
    saveas(f,sprintf('%s/PR_curve_difficult.fig',outputpath));
    close(f);
%[apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurve_Neg(categName,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,zeros(length(groundTruthBbs),1));
    [apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps] = computePRCurveTightBB(categName,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,zeros(length(groundTruthBbs),1));
    save(sprintf('%s/PRdata.mat',outputpath),'apScore','precision','recall','isTp','isFp','isMissed','gtIdx','maxOverlaps');
    f = figure('units','normalized','outerposition',[0 0 1 1],'Visible','Off');
    plot(recall, precision, '.-'); hold on;
    grid on; xlabel 'recall'; ylabel 'precision'; axis equal; axis([0,1,0,1]);
    title(sprintf('Class: %s, AP = %.3f', categName, apScore));
    saveas(f,sprintf('%s/PR_curve_all.png',outputpath));
    saveas(f,sprintf('%s/PR_curve_all.pdf',outputpath));
    saveas(f,sprintf('%s/PR_curve_all.fig',outputpath));
    close(f);
    allTpIdx = find(isTp);
    allFpIdx = find(isFp);
    allMissIdx = find(isMissed);
    allTpLabels = gtLabels(gtIdx(isTp));

    
    % pick neccessary detections only
    fprintf('picking neccessary detections...\n');
    nExamples = min(nExamples,size(allBb3d,1));
    topIdx = 1:nExamples;
    topTpIdx = allTpIdx(1:min(nExamples,numel(allTpIdx)));
    topTpLabels = allTpLabels(1:min(nExamples,numel(allTpIdx)));
    topFpIdx = allFpIdx(1:min(nExamples,numel(allFpIdx)));
    lowTpIdx = allTpIdx(end:-1:end-min(nExamples,numel(allTpIdx))+1);
    lowTpLabels = allTpLabels(end:-1:end-min(nExamples,numel(allTpIdx))+1);
    neededIdx = false(size(allBb3d,1),1);
    neededIdx(topIdx) = true;
    neededIdx(topTpIdx) = true;
    neededIdx(topFpIdx) = true;
    neededIdx(lowTpIdx) = true;
    allNeededIdx = find(neededIdx);
    allNeededOverlaps = maxOverlaps(neededIdx);
    tmp = false(size(allBb3d,1),1); tmp(topIdx) = true; topIdx = find(tmp(neededIdx));
    tmp = false(size(allBb3d,1),1); tmp(topTpIdx) = true; topTpIdx = find(tmp(neededIdx));
    tmp = false(size(allBb3d,1),1); tmp(topFpIdx) = true; topFpIdx = find(tmp(neededIdx));
    tmp = false(size(allBb3d,1),1); tmp(lowTpIdx) = true; lowTpIdx = find(tmp(neededIdx)); lowTpIdx = lowTpIdx(end:-1:1);
    neededBb3d = allBb3d(neededIdx,:);
    neededBb3dtight = allBb3dtight(neededIdx,:);
    neededBb2dDraw = allBb2dDraw(neededIdx,:);
    neededTestImgIds = allTestImgIds(neededIdx);
    neededInstancetNames = allModelInstanceNames(allInstancetNameIds(neededIdx));
    neededViewNames = allModelViewNames(allViewNameIds(neededIdx));
    
    neededisTp = isTp(neededIdx);
    neededMissIdxAll = allMissIdx;
    neededMissIdxGood = find(isMissed & gtLabels==1);
    neededMissIdxOcc = find(isMissed & gtLabels==2);
    neededMissIdxOthers = find(isMissed & gtLabels~=1 & gtLabels~=2);
    neededMissTestImgIdsAll = unique([groundTruthBbs(neededMissIdxAll).imageNum]);
    if submit,
        neededMissTestImgIdsGood = unique([groundTruthBbs(neededMissIdxGood).imageNum]);
    else
        neededMissTestImgIdsGood = ([groundTruthBbs(neededMissIdxGood).imageNum]);
    end
    neededMissTestImgIdsOcc = unique([groundTruthBbs(neededMissIdxOcc).imageNum]);
    neededMissTestImgIdsOthers = unique([groundTruthBbs(neededMissIdxOthers).imageNum]);

    
    % save masked images
    fprintf('generating output images...\n');
    maskedImageNames = cell(length(allNeededIdx),1);
    parfor i = 1:length(allNeededIdx),
        tmp = load([pointFolder '/feature_' num2str(neededTestImgIds(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
        modeltmp =load([modelFolder '/' categName '/' neededInstancetNames{i}  '/' neededViewNames{i} '.mat']);
           modeltmp = modeltmp.Model;
        %modeltmp = load([modelImageFolder '/' categName '/' neededInstancetNames{i} '/' neededViewNames{i} '.mat']);
        if ~isempty(groundTruthBbs),
            bbColor = [(~neededisTp(i)),neededisTp(i),0];
        else
            bbColor = [0 1 0];
        end
        gtIdxCurr = [groundTruthBbs.imageNum] == neededTestImgIds(i);      
        maskedImg = applyBbMaskTightBB(tmp.XYZworldframeTest,tmp.rgbTest,neededBb3d(i,:),neededBb3dtight(i,:),groundTruthBbs(gtIdxCurr),tmp.Rtilt,[0 1 0],modeltmp); 
        [~,gtBb2dDraw] = projectStructBbsTo2d(groundTruthBbs(gtIdxCurr),tmp.Rtilt);
        maskedImg = drawBbOnImage(maskedImg,neededBb2dDraw(i,:),bbColor);% draw detection BB
        for j = 1:size(gtBb2dDraw,1), % draw gt BB
             maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),[1 1 0]);
        end
        maskedImageNames{i} = sprintf('rank%03d-image%05d.jpg',i,neededTestImgIds(i));
        imwrite(maskedImg,sprintf('%s/%s',outputpath,maskedImageNames{i}));
    end
    
    % save missed ground truth
    bbColor = [1 1 0];
    missedGtImageNamesAll = cell(length(neededMissTestImgIdsAll),1);
    neededMissedGtBbs = groundTruthBbs(neededMissIdxAll);
    
    parfor i = 1:length(neededMissTestImgIdsAll),
        tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsAll(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
        maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
        gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsAll(i);
        [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
        for j = 1:size(gtBb2dDraw,1),
            maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
        end
        missedGtImageNamesAll{i} = sprintf('miss-image%05d-all.jpg',neededMissTestImgIdsAll(i));
        imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesAll{i}));
    end
    
    

    if ~submit,
        neededMissedGtBbs = groundTruthBbs(neededMissIdxGood);
        missedGtImageNamesGood =cell(length(neededMissedGtBbs),1);
        for i =1:length(neededMissedGtBbs)
            gtIdxCurr =neededMissIdxGood(i);
            ImgID =neededMissedGtBbs(i).imageNum;
            tmp = load([pointFolder '/feature_' num2str(ImgID) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            confall =allBb3d(:,7);
            confall(gtIdxall ~=gtIdxCurr|maxOverlaps==0) =-Inf;
            [closeBBhighconf,closeBBhighconfInd] = max(confall);
            if closeBBhighconf == -Inf,
                  maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            else
            closeBB3d =allBb3d(closeBBhighconfInd,:);
            closeBB3dtight = allBb3dtight(closeBBhighconfInd);
            modeltmp = load([modelImageFolder '/' categName '/' allModelInstanceNames{allInstancetNameIds(closeBBhighconfInd)} '/' allModelViewNames{allViewNameIds(closeBBhighconfInd)} '.mat']);
            maskedImg = applyBbMaskTightBB(tmp.XYZworldframeTest,tmp.rgbTest,closeBB3d,closeBB3dtight,neededMissedGtBbs(i),tmp.Rtilt,[0 1 0],modeltmp); 
            end
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(i),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1), % draw gt BB
                 maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),[1 1 0]);
            end
            missedGtImageNamesGood{i} = sprintf('%d-miss-image%05d-good.jpg',i,ImgID);
            missedGtImageNamesGoodConf(i) =closeBBhighconf;
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesGood{i}));

        end
        missedGtImageNamesOcc = cell(length(neededMissTestImgIdsOcc),1);
        missedGtImageNamesOthers = cell(length(neededMissTestImgIdsOthers),1);
       
    else
        missedGtImageNamesGood = cell(length(neededMissTestImgIdsGood),1);
        neededMissedGtBbs = groundTruthBbs(neededMissIdxGood);
        parfor i = 1:length(neededMissTestImgIdsGood),
            tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsGood(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsGood(i);
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1),
                maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
            end
            missedGtImageNamesGood{i} = sprintf('miss-image%05d-good.jpg',neededMissTestImgIdsGood(i));
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesGood{i}));
        end
        %}

        missedGtImageNamesOcc = cell(length(neededMissTestImgIdsOcc),1);
        neededMissedGtBbs = groundTruthBbs(neededMissIdxOcc);
        parfor i = 1:length(neededMissTestImgIdsOcc),
            tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsOcc(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsOcc(i);
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1),
                maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
            end
            missedGtImageNamesOcc{i} = sprintf('miss-image%05d-occ.jpg',neededMissTestImgIdsOcc(i));
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesOcc{i}));
        end
        %}

        missedGtImageNamesOthers = cell(length(neededMissTestImgIdsOthers),1);
        neededMissedGtBbs = groundTruthBbs(neededMissIdxOthers);
        for i = 1:length(neededMissTestImgIdsOthers),
            tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsOthers(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsOthers(i);
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1),
                maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
            end
            missedGtImageNamesOthers{i} = sprintf('miss-image%05d-others.jpg',neededMissTestImgIdsOthers(i));
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesOthers{i}));
        end
    
    end

    
    %% create html viewer
    fprintf('generating html file...\n');
    htmlFullName = [outputpath '/amazing_viewer.html'];
    pathBerkerly = relativepath('/n/fs/modelnet/post_segment/BerkerlysegImage_0.2/',outputpath);
    pathPlane = relativepath('/n/fs/modelnet/post_segment/PlanesegImage/',outputpath); 
    pathPlaneNew = relativepath('/n/fs/modelnet/post_segment/PlanesegImage_complete',outputpath); 
    
    htmlFile = fopen(htmlFullName,'w');
    if htmlFile < 0, error('cannot create file %s.html',htmlFullName); end
    fprintf(htmlFile,'<html><head><title>3D Detection Viewer</title></head><body>\n');
    
    % script to hide model images
    fprintf(htmlFile,'<script language="JavaScript" type="text/JavaScript">\n');
    fprintf(htmlFile,'<!--\n');
    fprintf(htmlFile,'function toggleDiv(targetid){\n');
    fprintf(htmlFile,'var target=document.getElementById(targetid);\n');
    fprintf(htmlFile,'if (target.style.display !== ''none''){ target.style.display = ''none''; }\n');
    fprintf(htmlFile,'else { target.style.display = ''block''; }\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'-->\n');
    fprintf(htmlFile,'</script>\n');
    
    fprintf(htmlFile,'<script language="JavaScript" type="text/JavaScript">\n');
    fprintf(htmlFile,'<!--\n');
    fprintf(htmlFile,'function selectDiv(id,callerList,targetList){\n');
    fprintf(htmlFile,'for (var i=0; i<callerList.length; i++){\n');
    fprintf(htmlFile,'\tdocument.getElementById(callerList[i]).style.fontWeight="normal";\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'document.getElementById(callerList[id-1]).style.fontWeight="bold";\n');
    fprintf(htmlFile,'for (var i=0; i<targetList.length; i++){\n');
    fprintf(htmlFile,'\tdocument.getElementById(targetList[i]).style.display="none";\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'document.getElementById(targetList[id-1]).style.display="block";\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'-->\n');
    fprintf(htmlFile,'</script>\n');
    
    fprintf(htmlFile,'<style type="text/css">\n');
    fprintf(htmlFile,'<!--\n');
    fprintf(htmlFile,'#modelButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#allButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#fpButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpAllButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpGoodButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpOccButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpNanButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpOutButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpAllButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpGoodButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpOccButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpNanButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpOutButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missAllButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missGoodButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missOccButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missOthersButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'.none { display: none; }\n');
    fprintf(htmlFile,'-->\n');
    fprintf(htmlFile,'</style>\n');
    
    % display header
    fprintf(htmlFile,'<center><h2>3D Detection Viewer<br>\n');
    fprintf(htmlFile,'%s(%d)\n',instanceName,length(allModelViewNames));
    try
    if ~isempty(rString), fprintf(htmlFile,'_%s\n',rString); end
    if ~isempty(sString), fprintf(htmlFile,'_%s\n',sString); end
    if ~isempty(dString), fprintf(htmlFile,'_%s\n',dString); end
    if ~isempty(tString), fprintf(htmlFile,'_%s\n',tString); end
    if ~isempty(xString), fprintf(htmlFile,'_%s\n',xString); end
    end
    fprintf(htmlFile,'</h2>\n');
    if ~submit
    % show model images
    nModels = length(allModelViewNames);
    nImagesPerRow = 1;
    nRows = ceil(nModels / nImagesPerRow);
    relativeModelImageFolder = relativepath(modelImageFolder,outputpath);
    fprintf(htmlFile,sprintf('<div id="modelButton" onClick="toggleDiv(''modelDiv'')"><h3>1. Detection Models : %d (click to show/hide)</h3></div>\n',nModels));
    fprintf(htmlFile,'<div id="modelDiv" class = "none">\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    
    height =200;
    for j = 1:nRows,
        % show images
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nModels, break; end
            imgNameCurr = [relativeModelImageFolder '/' categName '/' allModelInstanceNames{entryIdx} '/' allModelViewNames{entryIdx} '.jpg'];
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" />\n',imgNameCurr,height);
            fprintf(htmlFile,'\t<img src="./Model/%s" height="%d" />\n',[allModelViewNames{entryIdx} '_seg.jpg'],height);
            fprintf(htmlFile,'\t<img src="./Model/%s" height="%d" />\n',[allModelViewNames{entryIdx} '_mapping.jpg'],height);
            fprintf(htmlFile,'\t<img src="./Model/%s" height="%d" /></div></td>\n',[allModelViewNames{entryIdx} '_tpscores.jpg'],height);
            
        end
        fprintf(htmlFile,'</tr>\n');
        
        % show text write training detail here 
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nModels, break; end
            fprintf(htmlFile,'\t<td align="center">%s\n<br>',allModelViewNames{entryIdx});
            try
                iterinfortmp = load([modelFolder '/' categName '/' allModelInstanceNames{entryIdx} '/' allModelViewNames{entryIdx} '.mat'],'Model');
                iterinfor =iterinfortmp.Model.iter; 
                fprintf(htmlFile,'<br>');
                for iterid =1: size(iterinfor,1),
                    fprintf(htmlFile,'iter: %d. pSV: %d,nSV %d thr %.2f, +: %d, -: %d ,numNeg %d, numIm: %d<br>',iterinfor(iterid,1),iterinfor(iterid,2),iterinfor(iterid,3),iterinfor(iterid,4),iterinfor(iterid,5),iterinfor(iterid,6),iterinfor(iterid,7),iterinfor(iterid,8));
                end           
            end
            
            try
                fprintf(htmlFile,'Postive Model score : %f<br>',iterinfortmp.modelscore);
            end
           fprintf(htmlFile,'</td>');
        end
        fprintf(htmlFile,'</tr>\n');
        
        % insert an empty row for spacing
        fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;<td></tr>\n',nImagesPerRow);
    end
    fprintf(htmlFile,'</table>\n');
    fprintf(htmlFile,'</div>\n');
    end
    % show PR curve
    fprintf(htmlFile,'<h3>2. Precision Recall Curve</h3>\n');
    fprintf(htmlFile,'<a href="PR_curve_all.png"><img width=600 src="PR_curve_all.png"></a>\n');
    fprintf(htmlFile,'<a href="PR_curve_difficult.png"><img width=600 src="PR_curve_difficult.png"></a>\n');
    
    % show detection results
    fprintf(htmlFile,'<h3>3. Detection results</h3>\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    fprintf(htmlFile,'<tr>\n');
    fprintf(htmlFile,'<td><div id="allButton" style="font-weight:bold" onClick="selectDiv(1,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>All Detections</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="tpButton" onClick="selectDiv(2,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>True Positives</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="fpButton" onClick="selectDiv(3,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>False Positives</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="ltpButton" onClick="selectDiv(4,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>Low Conf True Positives</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="missButton" onClick="selectDiv(5,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>Misses</p></div></td>\n');
    fprintf(htmlFile,'</tr>\n');
    fprintf(htmlFile,'</table>\n');
    
    % all detections
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="allDiv" class = "none" style="display:block">\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    nRows = ceil(nExamples / nImagesPerRow);
    img = imread([outputpath '/' maskedImageNames{topIdx(1)}]);
    height = round(viewScale * size(img,1));
    for j = 1:nRows,
        % show images and detections
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nExamples, break; end
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topIdx(entryIdx)},height);
            TestID=str2double(regexp(maskedImageNames{topIdx(entryIdx)},'\d\d\d\d\d','match'));
%            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s/%04d.jpg" height="%d" /></div></td>\n',pathPlaneNew,TestID,height);
%            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s/%04d_floor.jpg" height="%d" /></div></td>\n',pathPlaneNew,TestID,height);
%            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s/%04d.jpg" height="%d" /></div></td>\n',pathBerkerly,TestID,height);
            
        end
        fprintf(htmlFile,'</tr>\n');
        
        % show names
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nExamples, break; end
            if size(neededBb3d,2)==7
                fprintf(htmlFile,'\t<td align="center">Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,neededBb3d(topIdx(entryIdx),7),neededTestImgIds(topIdx(entryIdx)),neededViewNames{topIdx(entryIdx)},allNeededOverlaps(topIdx(entryIdx)));
            else
                fprintf(htmlFile,'\t<td align="center">Rank%d (%.2f): Test_%05d-%s [overlap: %.2f] [occcell:%.2f]</td>\n',entryIdx,neededBb3d(topIdx(entryIdx),7),neededTestImgIds(topIdx(entryIdx)),neededViewNames{topIdx(entryIdx)},allNeededOverlaps(topIdx(entryIdx)),neededBb3d(topIdx(entryIdx),8));
            end
        end
        fprintf(htmlFile,'</tr>\n');
        
        % insert an empty row for spacing
        fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
    end
    fprintf(htmlFile,'</table></div>\n');
    
    % true positives
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="tpDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        fprintf(htmlFile,'<tr>\n');
        fprintf(htmlFile,'<td><div id="tpAllButton" style="font-weight:bold" onClick="selectDiv(1,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>All GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpGoodButton" onClick="selectDiv(2,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>Good GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpOccButton" onClick="selectDiv(3,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>Occluded GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpNanButton" onClick="selectDiv(4,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>NaN GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpOutButton" onClick="selectDiv(5,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>Out of Sight GT</p></div></td>\n');
        fprintf(htmlFile,'</tr>\n');
        fprintf(htmlFile,'</table>\n');
    
        % all gt
        fprintf(htmlFile,'<div id="tpAllDiv" class = "none" style="display:block">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nExamplesCurr = min(nExamples,numel(topTpIdx));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdx(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdx(entryIdx)),neededBb3d(topTpIdx(entryIdx),7),neededTestImgIds(topTpIdx(entryIdx)),neededViewNames{topTpIdx(entryIdx)},allNeededOverlaps(topTpIdx(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % good gt
        fprintf(htmlFile,'<div id="tpGoodDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels==1);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % occ gt
        fprintf(htmlFile,'<div id="tpOccDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels==2);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" " height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % nan gt
        fprintf(htmlFile,'<div id="tpNanDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels~=1 & topTpLabels~=2 & topTpLabels~=6);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                img = imread([outputpath '/' maskedImageNames{topTpIdxCurr(entryIdx)}]);
                height = round(viewScale * size(img,1));
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % out gt
        fprintf(htmlFile,'<div id="tpOutDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels==6);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                img = imread([outputpath '/' maskedImageNames{topTpIdxCurr(entryIdx)}]);
                width = round(viewScale * size(img,2));
                height = round(viewScale * size(img,1));
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
    fprintf(htmlFile,'</div>\n');
    
    % false positives
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="fpDiv" class = "none">\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    nRows = ceil(min(nExamples,numel(allFpIdx)) / nImagesPerRow);
    for j = 1:nRows,
        % show images and detections
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > min(nExamples,numel(allFpIdx)), break; end
            TestID=str2double(regexp(maskedImageNames{topFpIdx(entryIdx)},'\d\d\d\d\d','match'));
            pathBerkerly = relativepath('/n/fs/modelnet/post_segment/BerkerlysegImage_0.2/',outputpath);
            pathPlane = relativepath('/n/fs/modelnet/post_segment/PlanesegImage',outputpath); 
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topFpIdx(entryIdx)},height);
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s/%04d.jpg" height="%d" /></div></td>\n',pathPlane,TestID,height);
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s/%04d.jpg" height="%d" /></div></td>\n',pathBerkerly,TestID,height);           

        end
        fprintf(htmlFile,'</tr>\n');
        
        % show names
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > min(nExamples,numel(allFpIdx)), break; end
            fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topFpIdx(entryIdx)),neededBb3d(topFpIdx(entryIdx),7),neededTestImgIds(topFpIdx(entryIdx)),neededViewNames{topFpIdx(entryIdx)},allNeededOverlaps(topFpIdx(entryIdx)));
        end
        fprintf(htmlFile,'</tr>\n');
        
        % insert an empty row for spacing
        fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
    end
    fprintf(htmlFile,'</table></div>\n');
    
    % low conf true positives
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="ltpDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        fprintf(htmlFile,'<tr>\n');
        fprintf(htmlFile,'<td><div id="ltpAllButton" style="font-weight:bold" onClick="selectDiv(1,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>All GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpGoodButton" onClick="selectDiv(2,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>Good GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpOccButton" onClick="selectDiv(3,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>Occluded GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpNanButton" onClick="selectDiv(4,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>NaN GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpOutButton" onClick="selectDiv(5,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>Out of Sight GT</p></div></td>\n');
        fprintf(htmlFile,'</tr>\n');
        fprintf(htmlFile,'</table>\n');
    
        % all gt
        fprintf(htmlFile,'<div id="ltpAllDiv" class = "none" style="display:block">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nExamplesCurr = min(nExamples,numel(lowTpIdx));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdx(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdx(entryIdx)),neededBb3d(lowTpIdx(entryIdx),7),neededTestImgIds(lowTpIdx(entryIdx)),neededViewNames{lowTpIdx(entryIdx)},allNeededOverlaps(lowTpIdx(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % good gt
        fprintf(htmlFile,'<div id="ltpGoodDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels==1);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % occ gt
        fprintf(htmlFile,'<div id="ltpOccDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels==2);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % nan gt
        fprintf(htmlFile,'<div id="ltpNanDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels~=1 & lowTpLabels~=2 & lowTpLabels~=6);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % out gt
        fprintf(htmlFile,'<div id="ltpOutDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels==6);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
    fprintf(htmlFile,'</div>\n');
    
    % missed ground truth
    nImagesPerRow = 3;
    fprintf(htmlFile,'<div id="missDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        fprintf(htmlFile,'<tr>\n');
        fprintf(htmlFile,'<td><div id="missAllButton" style="font-weight:bold" onClick="selectDiv(1,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>All GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="missGoodButton" onClick="selectDiv(2,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>Good GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="missOccButton" onClick="selectDiv(3,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>Occluded GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="missOthersButton" onClick="selectDiv(4,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>Other GT</p></div></td>\n');
        fprintf(htmlFile,'</tr>\n');
        fprintf(htmlFile,'</table>\n');
    
        % all gt
        fprintf(htmlFile,'<div id="missAllDiv" class = "none" style="display:block">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesAll) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesAll), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesAll{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesAll), break; end
                fprintf(htmlFile,'\t<td align="center">%d. Test_%05d</td>\n',entryIdx,neededMissTestImgIdsAll(entryIdx));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % good gt
        nImagesPerRow = 1;
        fprintf(htmlFile,'<div id="missGoodDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesGood) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesGood), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesGood{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesGood), break; end
               try fprintf(htmlFile,'\t<td align="center">%d. Test_%05d Conf: %f</td>\n',entryIdx,neededMissTestImgIdsGood(entryIdx),missedGtImageNamesGoodConf(entryIdx));end
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        
        % occ gt
        fprintf(htmlFile,'<div id="missOccDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesOcc) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOcc), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesOcc{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOcc), break; end
                fprintf(htmlFile,'\t<td align="center">%d. Test_%05d</td>\n',entryIdx,neededMissTestImgIdsOcc(entryIdx));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        
        % other gt
        fprintf(htmlFile,'<div id="missOthersDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesOthers) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOthers), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesOthers{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOthers), break; end
                fprintf(htmlFile,'\t<td align="center">%d. Test_%05d</td>\n',entryIdx,neededMissTestImgIdsOthers(entryIdx));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
         %}
        fprintf(htmlFile,'</div>\n');
    
    fprintf(htmlFile,'</center></body></html>\n');
    fclose(htmlFile);
end