function visualizeProjected3dBb(bb,color,bbstruct,LineWidth)
    if size(bb,2) < 16, return; end
    if ~exist('color','var'), color = repmat([0,1,0],[size(bb,1),1]); end
    if ~exist('LineWidth','var'), LineWidth =3*ones(size(bb,1),1); end
    link = [1,2;
            1,3;
            2,4;
            3,4;
            1,5;
            2,6;
            3,7;
            4,8;
            5,6;
            5,7;
            6,8;
            7,8];
    for ii =1:size(bb,1)
        hold on;
        if exist('bbstruct','var')
            X = round(bb(ii,1:2:16));
            Y = round(bb(ii,2:2:16));
            idx = convhull(double(X),double(Y));
            on = zeros(size(X));
            on(idx) = 1;
            corners = get_corners_of_bb3d(bbstruct(ii));
            depth= corners([8 4 5 1 7 3 6 2],2);
            [~,occInd]=max(depth(~on));
            in= find(~on);
            occInd =in(occInd);
            
        else
            occInd =0;
        end
        for i = 1:size(link,1),
            if sum(link(i,:) ==occInd)
                plot([bb(ii,2*link(i,1)-1),bb(ii,2*link(i,2)-1)]',[bb(ii,2*link(i,1)),bb(ii,2*link(i,2))]','--', 'LineWidth',LineWidth(ii),'Color',color(1,:));
            else
                plot([bb(ii,2*link(i,1)-1),bb(ii,2*link(i,2)-1)]',[bb(ii,2*link(i,1)),bb(ii,2*link(i,2))]','-', 'LineWidth',LineWidth(ii),'Color',color(1,:));
            end
        end
        if size(bb,2)==17,
            for i = 1:size(bb,1),
                text(bb(i,9),bb(i,10),sprintf('%.2f',bb(i,17)),'background',color(1,:));
            end
        end
    end
end