function califuntesting = getCalifunction(dataFolder,modelFileCurr,testIdRange,trainIdRange,modelName,groundTruthBbs,gtLabels,outputPath,calitype,loadPrevMat)
saveModel =0;
loadPrevMat =1;
if strcmp(calitype,'no')
     califuntesting =@(x)x;
     try load(modelFileCurr);end
else
    load(modelFileCurr);
    %% use training 
    if strcmp(calitype,'trainingCali')
        if ~isfield(Model,'trainingCali')
        saveModel =1;
        [califuntraining,x,y,training_score_before,training_precision_before] = califunctionBaseonPRfit(Model.osall,Model.socreall,'uinformScore',0);
        trainingCali =struct('califun',califuntraining);
        Model.trainingCali =trainingCali;
        else 
             [~,~,~,training_score_before,training_precision_before] = califunctionBaseonPRfit(Model.osall,Model.socreall,'uinformScore',0);
        end
        califuntesting =Model.trainingCali.califun;

    %% use testing  
    elseif  strcmp(calitype,'testingCali')
        if  ~isfield(Model,'testingCali')||Model.testingCali.califun(-0.5)>1.1
            fprintf('getcali function')
            saveModel =1;
            [maxOverlaps,testing_score_before,testing_precision_before,recall_before,apScore_before]=getSingleModelAP(dataFolder,testIdRange,modelName,groundTruthBbs,gtLabels,1,loadPrevMat);
            apScore_before
            [califuntesting,x,y,testing_score_before,testing_precision_before] = califunctionBaseonPRfit(maxOverlaps,testing_score_before,'uinformScore',0);
            testingCali =struct('califun',califuntesting,'os',maxOverlaps,'score',testing_score_before,'pc',testing_precision_before,'ap',apScore_before);
            Model.testingCali =testingCali;
        end
        califuntesting =Model.testingCali.califun;
    elseif strcmp(calitype,'trainingCaliLocal')
        if  ~isfield(Model,'trainingCaliLocal')
             saveModel =1;
             [maxOverlaps,training_score_before,training_precision_before,recall_before,apScore_before]=getSingleModelAP(dataFolder,trainIdRange,modelName,groundTruthBbs,gtLabels,1,loadPrevMat);
            apScore_before
            [califuntesting,x,y,training_score_before,training_precision_before] = califunctionBaseonPRfit(maxOverlaps,training_score_before,'uinformScore',0);
            trainingCaliLocal =struct('califun',califuntesting,'os',maxOverlaps,'score',training_score_before,'pc',training_precision_before,'ap',apScore_before);
            Model.trainingCaliLocal =trainingCaliLocal;
        end
        califuntesting = Model.trainingCaliLocal.califun;
     elseif  strcmp(calitype,'validationCali')
        if  1%~isfield(Model,'validationCali')
            fprintf('getcali validationCali function')
            saveModel =1;
            [maxOverlaps,validation_score_before,validation_precision_before,recall_before,apScore_before]=getSingleModelAP(dataFolder,trainIdRange,modelName,groundTruthBbs,gtLabels,1,loadPrevMat);
            apScore_before
            [califuntesting,x,y,validation_score_before,validation_precision_before] = califunctionBaseonPRfit(maxOverlaps,validation_score_before,'uinformScore',0);
            validationCali =struct('califun',califuntesting,'os',maxOverlaps,'score',validation_score_before,'pc',validation_precision_before,'ap',apScore_before);
            Model.validationCali =validationCali;

        end
        califuntesting =Model.validationCali.califun;
    end
end


if saveModel
   save(modelFileCurr,'Model','-v6');
end

if exist('outputPath','var')     
       % [~,x,y,testing_score_before,testing_precision_before] = califunctionBaseonPRfit(testingCali.os,testingCali.score,'uinformScore',0);
        f = figure('units','normalized','outerposition',[0 0 1 1],'Visible','Off');
        try plot(Model.testingCali.score,Model.testingCali.pc,'-b');catch ee, plot(0,0,'-b');end; hold on;
        try plot(Model.trainingCaliLocal.score,Model.trainingCaliLocal.pc,'-m'); catch ee, plot(0,0,'-m');end
        try plot(Model.validationCali.score,Model.validationCali.pc,'-g');catch ee, plot(0,0,'-k'); end
        
        try plot(Model.testingCali.score,Model.testingCali.califun(Model.testingCali.score),'-r');catch ee, plot(0,0,'-r'); end
        try plot(Model.testingCali.score,Model.trainingCaliLocal.califun(Model.testingCali.score),'-k');catch ee,  plot(0,0,'-k'); end
        try plot(Model.testingCali.score,Model.validationCali.califun(Model.testingCali.score),'-c');catch ee,plot(0,0,'-r'); end
        
        legend([{'testing mapping'},{'training mapping'},{'validation mapping'},...
                {'function fit testing'},{'function fit training'},{'function fit validation'}],...
               'Location','West');
        try  text(min(Model.testingCali.score)+0.1,0.8,sprintf('testing AP: %f',Model.testingCali.ap));end
        try  text(min(Model.testingCali.score)+0.1,0.7,sprintf('training AP: %f',Model.trainingCaliLocal.ap));end
        try  text(min(Model.validationCali.score)+0.1,0.9,sprintf('validation AP: %f',Model.validationCali.ap));end
        grid on; xlabel 'conf'; ylabel 'precision'; axis tight;
        try print(f,'-djpeg',sprintf('%s/Model/%s_mapping.jpg',outputPath,modelName));end
        close(f);

        try
        [~,tpscores,fscores] = calibrationBaseOnPR(Model.osall,Model.socreall);
        f = figure('units','normalized','outerposition',[0 0 1 1],'Visible','Off');
        plot(tpscores(:), '.-');
        hold on;grid on; 
        if isempty(tpscores),
            sample=1;
        else
            sample =round(size(fscores(:),1)/length(tpscores));
        end
        plot(fscores(1:sample:size(fscores(:),1)),'.-r');
        thres =[0.1:0.1:0.6];
        thrscore  = tpscores(ceil(thres*length(tpscores)));
        plot([1:size(tpscores(:),1)],thrscore*ones(1,size(tpscores(:),1)));
        legend('pos','neg','0.1','0.2','0.3','0.5','0.6');
        ylabel 'tpscores'; axis tight; 
        end
        try print(f,'-djpeg',sprintf('%s/Model/%s_tpscores.jpg',outputPath,modelName));end
        try imwrite(getImagesc(Model.Seg),sprintf('%s/Model/%s_seg.jpg',outputPath,modelName)); end
        close(f);
end
end

