function [bb2d,meshObj]=get2dtightBB(Model,bb3d,Rtilt)
centers = bb3d(:,1:3) + 0.5*bb3d(:,4:6);
ConstsDetection;
offfile = ['/n/fs/modelnet/warehouseQuery/Data/' consts.classNames{Model.classId} '/' Model.name '/'  Model.name '.off'];
% put mesh to result center location,
% with Model rotation, scale, tilt angle


offobj = offLoader(offfile);
Ryzswi = [1, 0, 0; 0, 0, 1; 0, 1, 0];
vmat = Ryzswi * offobj.vmat;
Robj = genRotMat(Model.Rotation*pi);
bb2d =nan(size(bb3d,1),5);
for i =1:size(bb3d,1)
    objx =centers(i,1);
    objy =centers(i,3);
    objz =centers(i,2);% depth
    vmatMoved = scalePoints(vmat, [objx;objy;objz], [1,1,1]*Model.Scale);
    vmatMoved = scalePoints(Robj *vmatMoved, [objx;objy;objz], [1,1,1]*Model.Scale);
    vmatMoved([1,3,2],:) =vmatMoved([1,2,3],:);
    if i ==1,
        meshObj.vertices = vmatMoved;
        meshObj.faces =offobj.fmat;
    end
    % project To 2D 
    [points2d,z3] = project3dPtsTo2d(vmatMoved',Rtilt);
    
    bb2d(i,:) =[min(points2d),max(points2d)-min(points2d),bb3d(i,7)];
end
end


function R = genRotMat(theta)

R = [cos(theta), 0, -sin(theta)
    0, 1, 0
    sin(theta), 0, cos(theta)];

end

function R = genTiltMat(theta)

R = [1, 0, 0
    0, cos(theta), -sin(theta)
    0,  sin(theta), cos(theta)];

end


function coornew = scalePoints(coor, center, size)

% function coornew = scalePoints(coor, box)
% 
% parameters:
%   coor: 3*n coordinates of n points
%   center: 3*1 the center of new point cloud
%   size: 3*1 the size of new point cloud

minv = min(coor, [], 2);
maxv = max(coor, [], 2);
oldCenter = (minv+maxv)/2;
oldSize = maxv - minv;
%size defined by height
if isempty(size)
    scale =1;
else
    scale =size(2)./ oldSize(2);
end
%scale = min(size./ oldSize);
coornew = bsxfun(@plus, scale * coor, center-scale*oldCenter);
end