    instanceName = modelName;
    allTpIdx = find(isTp);
    allFpIdx = find(isFp);
    allMissIdx = find(isMissed);
    allTpLabels = gtLabels(gtIdx(isTp));
    submit = 1;
    QualityValue=20;
    % pick neccessary detections only
    fprintf('picking neccessary detections...\n');
    nExamples = min(nExamples,size(allBb3d,1));
    topIdx = 1:nExamples;
    topTpIdx = allTpIdx(1:min(nExamples,numel(allTpIdx)));
    topTpLabels = allTpLabels(1:min(nExamples,numel(allTpIdx)));
    topFpIdx = allFpIdx(1:min(nExamples,numel(allFpIdx)));
    lowTpIdx = allTpIdx(end:-1:end-min(nExamples,numel(allTpIdx))+1);
    lowTpLabels = allTpLabels(end:-1:end-min(nExamples,numel(allTpIdx))+1);
    neededIdx = false(size(allBb3d,1),1);
    neededIdx(topIdx) = true;
    neededIdx(topTpIdx) = true;
    neededIdx(topFpIdx) = true;
    neededIdx(lowTpIdx) = true;
    allNeededIdx = find(neededIdx);
    allNeededOverlaps = maxOverlaps(neededIdx);
    tmp = false(size(allBb3d,1),1); tmp(topIdx) = true; topIdx = find(tmp(neededIdx));
    tmp = false(size(allBb3d,1),1); tmp(topTpIdx) = true; topTpIdx = find(tmp(neededIdx));
    tmp = false(size(allBb3d,1),1); tmp(topFpIdx) = true; topFpIdx = find(tmp(neededIdx));
    tmp = false(size(allBb3d,1),1); tmp(lowTpIdx) = true; lowTpIdx = find(tmp(neededIdx)); lowTpIdx = lowTpIdx(end:-1:1);
    neededBb3d = allBb3d(neededIdx,:);
    neededBb3dtight = allBb3dtight(neededIdx,:);
    neededBb2dDraw = allBb2dDraw(neededIdx,:);
    neededTestImgIds = allTestImgIds(neededIdx);
    neededInstancetNames = allModelInstanceNames(allInstancetNameIds(neededIdx));
    neededViewNames = allModelViewNames(allViewNameIds(neededIdx));
    
    neededisTp = isTp(neededIdx);
    neededMissIdxAll = allMissIdx;
    neededMissIdxGood = find(isMissed & gtLabels==1);
    neededMissIdxOcc = find(isMissed & gtLabels==2);
    neededMissIdxOthers = find(isMissed & gtLabels~=1 & gtLabels~=2);
    neededMissTestImgIdsAll = unique([groundTruthBbs(neededMissIdxAll).imageNum]);
    if submit,
        neededMissTestImgIdsGood = unique([groundTruthBbs(neededMissIdxGood).imageNum]);
    else
        neededMissTestImgIdsGood = ([groundTruthBbs(neededMissIdxGood).imageNum]);
    end
    neededMissTestImgIdsOcc = unique([groundTruthBbs(neededMissIdxOcc).imageNum]);
    neededMissTestImgIdsOthers = unique([groundTruthBbs(neededMissIdxOthers).imageNum]);

    
    % save masked images
    fprintf('generating output images...\n');
    maskedImageNames = cell(length(allNeededIdx),1);
    parfor i = 1:length(allNeededIdx),
        tmp = load([pointFolder '/feature_' num2str(neededTestImgIds(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
        modeltmp =load([modelFolder '/' categName '/' neededInstancetNames{i} '/' neededViewNames{i} '.mat']);
        modeltmp = modeltmp.Model;
        %modeltmp = load([modelImageFolder '/' categName '/' neededInstancetNames{i} '/' neededViewNames{i} '.mat']);
        if ~isempty(groundTruthBbs),
            bbColor = [(~neededisTp(i)),neededisTp(i),0];
        else
            bbColor = [0 1 0];
        end
        gtIdxCurr = [groundTruthBbs.imageNum] == neededTestImgIds(i);      
        maskedImg = applyBbMaskTightBB(tmp.XYZworldframeTest,tmp.rgbTest,neededBb3d(i,:),neededBb3dtight(i,:),groundTruthBbs(gtIdxCurr),tmp.Rtilt,[0 1 0],modeltmp); 
        [~,gtBb2dDraw] = projectStructBbsTo2d(groundTruthBbs(gtIdxCurr),tmp.Rtilt);
        maskedImg = drawBbOnImage(maskedImg,neededBb2dDraw(i,:),bbColor);% draw detection BB
        for j = 1:size(gtBb2dDraw,1), % draw gt BB
             maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),[1 1 0]);
        end
        maskedImageNames{i} = sprintf('rank%03d-image%05d.jpg',i,neededTestImgIds(i));
        imwrite(maskedImg,sprintf('%s/%s',outputpath,maskedImageNames{i}),'Quality',QualityValue);
    end
    
    % save missed ground truth
    bbColor = [1 1 0];
    missedGtImageNamesAll = cell(length(neededMissTestImgIdsAll),1);
    neededMissedGtBbs = groundTruthBbs(neededMissIdxAll);
    
    parfor i = 1:length(neededMissTestImgIdsAll),
        tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsAll(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
        maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
        gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsAll(i);
        [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
        for j = 1:size(gtBb2dDraw,1),
            maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
        end
        missedGtImageNamesAll{i} = sprintf('miss-image%05d-all.jpg',neededMissTestImgIdsAll(i));
        imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesAll{i}),'Quality',QualityValue);
    end
    
    

    if ~submit,
        neededMissedGtBbs = groundTruthBbs(neededMissIdxGood);
        missedGtImageNamesGood =cell(length(neededMissedGtBbs),1);
        for i =1:length(neededMissedGtBbs)
            gtIdxCurr =neededMissIdxGood(i);
            ImgID =neededMissedGtBbs(i).imageNum;
            tmp = load([pointFolder '/feature_' num2str(ImgID) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            confall =allBb3d(:,7);
            confall(gtIdxall ~=gtIdxCurr|maxOverlaps==0) =-Inf;
            [closeBBhighconf,closeBBhighconfInd] = max(confall);
            if closeBBhighconf == -Inf,
                  maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            else
            closeBB3d =allBb3d(closeBBhighconfInd,:);
            closeBB3dtight = allBb3dtight(closeBBhighconfInd);
            modeltmp = load([modelImageFolder '/' categName '/' allModelInstanceNames{allInstancetNameIds(closeBBhighconfInd)} '/' allModelViewNames{allViewNameIds(closeBBhighconfInd)} '.mat']);
            maskedImg = applyBbMaskTightBB(tmp.XYZworldframeTest,tmp.rgbTest,closeBB3d,closeBB3dtight,neededMissedGtBbs(i),tmp.Rtilt,[0 1 0],modeltmp); 
            end
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(i),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1), % draw gt BB
                 maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),[1 1 0]);
            end
            missedGtImageNamesGood{i} = sprintf('%d-miss-image%05d-good.jpg',i,ImgID);
            missedGtImageNamesGoodConf(i) =closeBBhighconf;
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesGood{i}),'Quality',QualityValue);

        end
        
        
    else
        missedGtImageNamesGood = cell(length(neededMissTestImgIdsGood),1);
        neededMissedGtBbs = groundTruthBbs(neededMissIdxGood);
        parfor i = 1:length(neededMissTestImgIdsGood),
            tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsGood(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsGood(i);
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1),
                maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
            end
            missedGtImageNamesGood{i} = sprintf('miss-image%05d-good.jpg',neededMissTestImgIdsGood(i));
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesGood{i}),'Quality',QualityValue);
        end
        %}

        missedGtImageNamesOcc = cell(length(neededMissTestImgIdsOcc),1);
        neededMissedGtBbs = groundTruthBbs(neededMissIdxOcc);
        parfor i = 1:length(neededMissTestImgIdsOcc),
            tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsOcc(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsOcc(i);
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1),
                maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
            end
            missedGtImageNamesOcc{i} = sprintf('miss-image%05d-occ.jpg',neededMissTestImgIdsOcc(i));
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesOcc{i}),'Quality',QualityValue);
        end
        %}

        missedGtImageNamesOthers = cell(length(neededMissTestImgIdsOthers),1);
        neededMissedGtBbs = groundTruthBbs(neededMissIdxOthers);
        for i = 1:length(neededMissTestImgIdsOthers),
            tmp = load([pointFolder '/feature_' num2str(neededMissTestImgIdsOthers(i)) '.mat'],'XYZworldframeTest','rgbTest','Rtilt');
            maskedImg = pointsToImage(tmp.XYZworldframeTest,tmp.rgbTest,tmp.Rtilt);
            gtIdxCurr = [neededMissedGtBbs.imageNum] == neededMissTestImgIdsOthers(i);
            [~,gtBb2dDraw] = projectStructBbsTo2d(neededMissedGtBbs(gtIdxCurr),tmp.Rtilt);
            for j = 1:size(gtBb2dDraw,1),
                maskedImg = drawBbOnImage(maskedImg,gtBb2dDraw(j,:),bbColor);
            end
            missedGtImageNamesOthers{i} = sprintf('miss-image%05d-others.jpg',neededMissTestImgIdsOthers(i));
            imwrite(maskedImg,sprintf('%s/%s',outputpath,missedGtImageNamesOthers{i}),'Quality',QualityValue);
        end
    
    end

    
    %% create html viewer
    fprintf('generating html file...\n');
    htmlFullName = [outputpath '/index.html'];
    delete(htmlFullName);
    htmlFile = fopen(htmlFullName,'w');
    if htmlFile < 0, error('cannot create file %s.html',htmlFullName); end
    fprintf(htmlFile,'<html><head><title>Sliding Shape Detection Result Viewer</title></head><body>\n');
    
    % script to hide model images
    fprintf(htmlFile,'<script language="JavaScript" type="text/JavaScript">\n');
    fprintf(htmlFile,'<!--\n');
    fprintf(htmlFile,'function toggleDiv(targetid){\n');
    fprintf(htmlFile,'var target=document.getElementById(targetid);\n');
    fprintf(htmlFile,'if (target.style.display !== ''none''){ target.style.display = ''none''; }\n');
    fprintf(htmlFile,'else { target.style.display = ''block''; }\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'-->\n');
    fprintf(htmlFile,'</script>\n');
    
    fprintf(htmlFile,'<script language="JavaScript" type="text/JavaScript">\n');
    fprintf(htmlFile,'<!--\n');
    fprintf(htmlFile,'function selectDiv(id,callerList,targetList){\n');
    fprintf(htmlFile,'for (var i=0; i<callerList.length; i++){\n');
    fprintf(htmlFile,'\tdocument.getElementById(callerList[i]).style.fontWeight="normal";\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'document.getElementById(callerList[id-1]).style.fontWeight="bold";\n');
    fprintf(htmlFile,'for (var i=0; i<targetList.length; i++){\n');
    fprintf(htmlFile,'\tdocument.getElementById(targetList[i]).style.display="none";\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'document.getElementById(targetList[id-1]).style.display="block";\n');
    fprintf(htmlFile,'}\n');
    fprintf(htmlFile,'-->\n');
    fprintf(htmlFile,'</script>\n');
    
    fprintf(htmlFile,'<style type="text/css">\n');
    fprintf(htmlFile,'<!--\n');
    fprintf(htmlFile,'#modelButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#allButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#fpButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpAllButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpGoodButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpOccButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpNanButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#tpOutButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpAllButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpGoodButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpOccButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpNanButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#ltpOutButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missAllButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missGoodButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missOccButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'#missOthersButton { cursor: hand; cursor:pointer;}\n');
    fprintf(htmlFile,'.none { display: none; }\n');
    fprintf(htmlFile,'-->\n');
    fprintf(htmlFile,'</style>\n');
    
    % display header
    fprintf(htmlFile,'<center><h2>Sliding Shape Detection Result Viewer<br>\n');
    fprintf(htmlFile,'%s\n',instanceName);
    try
    if ~isempty(rString), fprintf(htmlFile,'_%s\n',rString); end
    if ~isempty(sString), fprintf(htmlFile,'_%s\n',sString); end
    if ~isempty(dString), fprintf(htmlFile,'_%s\n',dString); end
    if ~isempty(tString), fprintf(htmlFile,'_%s\n',tString); end
    if ~isempty(xString), fprintf(htmlFile,'_%s\n',xString); end
    end
    fprintf(htmlFile,'</h2>\n');
    if ~submit
    % show model images
    nModels = length(allModelViewNames);
    nImagesPerRow = 1;
    nRows = ceil(nModels / nImagesPerRow);
    relativeModelImageFolder = relativepath(modelImageFolder,outputpath);
    fprintf(htmlFile,sprintf('<div id="modelButton" onClick="toggleDiv(''modelDiv'')"><h3>1. Detection Models : %d (click to show/hide)</h3></div>\n',nModels));
    fprintf(htmlFile,'<div id="modelDiv" class = "none">\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    
    height =200;
    for j = 1:nRows,
        % show images
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nModels, break; end
            imgNameCurr = [relativeModelImageFolder '/' categName '/' allModelInstanceNames{entryIdx} '/' allModelViewNames{entryIdx} '.jpg'];
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" />\n',imgNameCurr,height);
            fprintf(htmlFile,'\t<img src="./Model/%s" height="%d" />\n',[allModelViewNames{entryIdx} '_mapping.jpg'],height);
            fprintf(htmlFile,'\t<img src="./Model/%s" height="%d" /></div></td>\n',[allModelViewNames{entryIdx} '_tpscores.jpg'],height);
        end
        fprintf(htmlFile,'</tr>\n');
        
        % show text write training detail here 
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nModels, break; end
            fprintf(htmlFile,'\t<td align="center">%s\n<br>',allModelViewNames{entryIdx});
            try
                iterinfortmp = load([modelFolder '/' categName '/' allModelInstanceNames{entryIdx} '/' allModelViewNames{entryIdx} '.mat'],'Model');
                iterinfor =iterinfortmp.Model.iter; 
                fprintf(htmlFile,'<br>');
                for iterid =1: size(iterinfor,1),
                    fprintf(htmlFile,'iter: %d. pSV: %d,nSV %d thr %.2f, +: %d, -: %d ,numNeg %d, numIm: %d<br>',iterinfor(iterid,1),iterinfor(iterid,2),iterinfor(iterid,3),iterinfor(iterid,4),iterinfor(iterid,5),iterinfor(iterid,6),iterinfor(iterid,7),iterinfor(iterid,8));
                end           
            end
            
            try
                fprintf(htmlFile,'Postive Model score : %f<br>',iterinfortmp.modelscore);
            end
           fprintf(htmlFile,'</td>');
        end
        fprintf(htmlFile,'</tr>\n');
        
        % insert an empty row for spacing
        fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;<td></tr>\n',nImagesPerRow);
    end
    fprintf(htmlFile,'</table>\n');
    fprintf(htmlFile,'</div>\n');
    end
    % show PR curve
    fprintf(htmlFile,'<h3> Precision Recall Curve</h3>\n');
    fprintf(htmlFile,'<a><img width=600 src="PR_curve_all.png"></a>\n');
    fprintf(htmlFile,'<a><img width=600 src="PR_curve_difficult.png"></a>\n');
    
    % show detection results
    fprintf(htmlFile,'<h3> Detection results</h3>\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    fprintf(htmlFile,'<tr>\n');
    fprintf(htmlFile,'<td><div id="allButton" style="font-weight:bold" onClick="selectDiv(1,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>All Detections</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="tpButton" onClick="selectDiv(2,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>True Positives</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="fpButton" onClick="selectDiv(3,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>False Positives</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="ltpButton" onClick="selectDiv(4,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>Low Conf True Positives</p></div></td>\n');
    fprintf(htmlFile,'<td><div id="missButton" onClick="selectDiv(5,[''allButton'',''tpButton'',''fpButton'',''ltpButton'',''missButton''],[''allDiv'',''tpDiv'',''fpDiv'',''ltpDiv'',''missDiv''])"><p>Misses</p></div></td>\n');
    fprintf(htmlFile,'</tr>\n');
    fprintf(htmlFile,'</table>\n');
    
    % all detections
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="allDiv" class = "none" style="display:block">\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    nRows = ceil(nExamples / nImagesPerRow);
    img = imread([outputpath '/' maskedImageNames{topIdx(1)}]);
    width = round(viewScale * size(img,2));
    height = round(viewScale * size(img,1));
    for j = 1:nRows,
        % show images and detections
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nExamples, break; end
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topIdx(entryIdx)},height);
        end
        fprintf(htmlFile,'</tr>\n');
        
        % show names
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > nExamples, break; end
            fprintf(htmlFile,'\t<td align="center">Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,neededBb3d(topIdx(entryIdx),7),neededTestImgIds(topIdx(entryIdx)),neededViewNames{topIdx(entryIdx)},allNeededOverlaps(topIdx(entryIdx)));
        end
        fprintf(htmlFile,'</tr>\n');
        
        % insert an empty row for spacing
        fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
    end
    fprintf(htmlFile,'</table></div>\n');
    
    % true positives
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="tpDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        fprintf(htmlFile,'<tr>\n');
        fprintf(htmlFile,'<td><div id="tpAllButton" style="font-weight:bold" onClick="selectDiv(1,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>3D+ GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpGoodButton" onClick="selectDiv(2,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>3D GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpOccButton" onClick="selectDiv(3,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>Occluded GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpNanButton" onClick="selectDiv(4,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>NaN GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="tpOutButton" onClick="selectDiv(5,[''tpAllButton'',''tpGoodButton'',''tpOccButton'',''tpNanButton'',''tpOutButton''],[''tpAllDiv'',''tpGoodDiv'',''tpOccDiv'',''tpNanDiv'',''tpOutDiv''])"><p>Out of Sight GT</p></div></td>\n');
        fprintf(htmlFile,'</tr>\n');
        fprintf(htmlFile,'</table>\n');
    
        % all gt
        fprintf(htmlFile,'<div id="tpAllDiv" class = "none" style="display:block">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nExamplesCurr = min(nExamples,numel(topTpIdx));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdx(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdx(entryIdx)),neededBb3d(topTpIdx(entryIdx),7),neededTestImgIds(topTpIdx(entryIdx)),neededViewNames{topTpIdx(entryIdx)},allNeededOverlaps(topTpIdx(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % good gt
        fprintf(htmlFile,'<div id="tpGoodDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels==1);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % occ gt
        fprintf(htmlFile,'<div id="tpOccDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels==2);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" " height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % nan gt
        fprintf(htmlFile,'<div id="tpNanDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels~=1 & topTpLabels~=2 & topTpLabels~=6);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                img = imread([outputpath '/' maskedImageNames{topTpIdxCurr(entryIdx)}]);
                height = round(viewScale * size(img,1));
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % out gt
        fprintf(htmlFile,'<div id="tpOutDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        topTpIdxCurr = topTpIdx(topTpLabels==6);
        nExamplesCurr = min(nExamples,numel(topTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                img = imread([outputpath '/' maskedImageNames{topTpIdxCurr(entryIdx)}]);
                width = round(viewScale * size(img,2));
                height = round(viewScale * size(img,1));
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topTpIdxCurr(entryIdx)),neededBb3d(topTpIdxCurr(entryIdx),7),neededTestImgIds(topTpIdxCurr(entryIdx)),neededViewNames{topTpIdxCurr(entryIdx)},allNeededOverlaps(topTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
    fprintf(htmlFile,'</div>\n');
    
    % false positives
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="fpDiv" class = "none">\n');
    fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
    nRows = ceil(min(nExamples,numel(allFpIdx)) / nImagesPerRow);
    for j = 1:nRows,
        % show images and detections
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > min(nExamples,numel(allFpIdx)), break; end
            fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{topFpIdx(entryIdx)},height);
        end
        fprintf(htmlFile,'</tr>\n');
        
        % show names
        fprintf(htmlFile,'<tr>\n');
        for i = 1:nImagesPerRow,
            entryIdx = (j-1)*nImagesPerRow+i;
            if entryIdx > min(nExamples,numel(allFpIdx)), break; end
            fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(topFpIdx(entryIdx)),neededBb3d(topFpIdx(entryIdx),7),neededTestImgIds(topFpIdx(entryIdx)),neededViewNames{topFpIdx(entryIdx)},allNeededOverlaps(topFpIdx(entryIdx)));
        end
        fprintf(htmlFile,'</tr>\n');
        
        % insert an empty row for spacing
        fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
    end
    fprintf(htmlFile,'</table></div>\n');
    
    % low conf true positives
    nImagesPerRow = 1;
    fprintf(htmlFile,'<div id="ltpDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        fprintf(htmlFile,'<tr>\n');
        fprintf(htmlFile,'<td><div id="ltpAllButton" style="font-weight:bold" onClick="selectDiv(1,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>3D+ GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpGoodButton" onClick="selectDiv(2,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>3D GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpOccButton" onClick="selectDiv(3,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>Occluded GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpNanButton" onClick="selectDiv(4,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>NaN GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="ltpOutButton" onClick="selectDiv(5,[''ltpAllButton'',''ltpGoodButton'',''ltpOccButton'',''ltpNanButton'',''ltpOutButton''],[''ltpAllDiv'',''ltpGoodDiv'',''ltpOccDiv'',''ltpNanDiv'',''ltpOutDiv''])"><p>Out of Sight GT</p></div></td>\n');
        fprintf(htmlFile,'</tr>\n');
        fprintf(htmlFile,'</table>\n');
    
        % all gt
        fprintf(htmlFile,'<div id="ltpAllDiv" class = "none" style="display:block">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nExamplesCurr = min(nExamples,numel(lowTpIdx));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdx(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdx(entryIdx)),neededBb3d(lowTpIdx(entryIdx),7),neededTestImgIds(lowTpIdx(entryIdx)),neededViewNames{lowTpIdx(entryIdx)},allNeededOverlaps(lowTpIdx(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % good gt
        fprintf(htmlFile,'<div id="ltpGoodDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels==1);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % occ gt
        fprintf(htmlFile,'<div id="ltpOccDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels==2);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % nan gt
        fprintf(htmlFile,'<div id="ltpNanDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels~=1 & lowTpLabels~=2 & lowTpLabels~=6);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % out gt
        fprintf(htmlFile,'<div id="ltpOutDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        lowTpIdxCurr = lowTpIdx(lowTpLabels==6);
        nExamplesCurr = min(nExamples,numel(lowTpIdxCurr));
        nRows = ceil(nExamplesCurr / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',maskedImageNames{lowTpIdxCurr(entryIdx)},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > nExamplesCurr, break; end
                fprintf(htmlFile,'\t<td align="center">%d. Rank%d (%.2f): Test_%05d-%s [overlap: %.2f]</td>\n',entryIdx,allNeededIdx(lowTpIdxCurr(entryIdx)),neededBb3d(lowTpIdxCurr(entryIdx),7),neededTestImgIds(lowTpIdxCurr(entryIdx)),neededViewNames{lowTpIdxCurr(entryIdx)},allNeededOverlaps(lowTpIdxCurr(entryIdx)));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
    fprintf(htmlFile,'</div>\n');
    
    % missed ground truth
    nImagesPerRow = 3;
    fprintf(htmlFile,'<div id="missDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        fprintf(htmlFile,'<tr>\n');
        fprintf(htmlFile,'<td><div id="missAllButton" style="font-weight:bold" onClick="selectDiv(1,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>3D+ GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="missGoodButton" onClick="selectDiv(2,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>3D GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="missOccButton" onClick="selectDiv(3,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>Occluded GT</p></div></td>\n');
        fprintf(htmlFile,'<td><div id="missOthersButton" onClick="selectDiv(4,[''missAllButton'',''missGoodButton'',''missOccButton'',''missOthersButton''],[''missAllDiv'',''missGoodDiv'',''missOccDiv'',''missOthersDiv''])"><p>Other GT</p></div></td>\n');
        fprintf(htmlFile,'</tr>\n');
        fprintf(htmlFile,'</table>\n');
    
        % all gt
        fprintf(htmlFile,'<div id="missAllDiv" class = "none" style="display:block">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesAll) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesAll), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesAll{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesAll), break; end
                fprintf(htmlFile,'\t<td align="center">%d. Test_%05d</td>\n',entryIdx,neededMissTestImgIdsAll(entryIdx));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        % good gt
        nImagesPerRow = 1;
        fprintf(htmlFile,'<div id="missGoodDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesGood) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesGood), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesGood{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesGood), break; end
               try fprintf(htmlFile,'\t<td align="center">%d. Test_%05d Conf: %f</td>\n',entryIdx,neededMissTestImgIdsGood(entryIdx),missedGtImageNamesGoodConf(entryIdx));end
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        
        % occ gt
        fprintf(htmlFile,'<div id="missOccDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesOcc) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOcc), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesOcc{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOcc), break; end
                fprintf(htmlFile,'\t<td align="center">%d. Test_%05d</td>\n',entryIdx,neededMissTestImgIdsOcc(entryIdx));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
        
        
        % other gt
        fprintf(htmlFile,'<div id="missOthersDiv" class = "none">\n');
        fprintf(htmlFile,'<table style="overflow:hidden; margin:10px" cellpadding="10">\n');
        nRows = ceil(length(missedGtImageNamesOthers) / nImagesPerRow);
        for j = 1:nRows,
            % show images and detections
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOthers), break; end
                fprintf(htmlFile,'\t<td><div style="position:relative;"><img src="%s" height="%d" /></div></td>\n',missedGtImageNamesOthers{entryIdx},height);
            end
            fprintf(htmlFile,'</tr>\n');

            % show names
            fprintf(htmlFile,'<tr>\n');
            for i = 1:nImagesPerRow,
                entryIdx = (j-1)*nImagesPerRow+i;
                if entryIdx > length(missedGtImageNamesOthers), break; end
                fprintf(htmlFile,'\t<td align="center">%d. Test_%05d</td>\n',entryIdx,neededMissTestImgIdsOthers(entryIdx));
            end
            fprintf(htmlFile,'</tr>\n');

            % insert an empty row for spacing
            fprintf(htmlFile,'<tr><td colspan="%d">&nbsp;</td></tr>\n',nImagesPerRow);
        end
        fprintf(htmlFile,'</table></div>\n');
         %}
        fprintf(htmlFile,'</div>\n');
    
    fprintf(htmlFile,'</center></body></html>\n');
    fclose(htmlFile);