majorSeg_Threshold = 0.001;
numOfSegConsiderLimit =2;
accidentalGetin_Threshold =0.01;
numberOfexample = 100;
try 
     load([outputpath '/SegScoreAll.mat'],'scoreAll');
catch
mkdir(outputpath);
scoreAll =nan(size(allBb3d,1),4);
for i =1:size(allBb3d,1)
    display(i/size(allBb3d,1))
    imageNum =allTestImgIds(i);
    tmp = load([featurepara.pointpath 'feature_' num2str(imageNum) '.mat'],'XYZworldframeTest','Rtilt','imgRgb');
    XYZworldframeTest =tmp.XYZworldframeTest;
    [refineMask]= getPlanSeg_complete([],[],[],imageNum);
    segMask = refineMask(:);
    Rtilt =tmp.Rtilt;
    imgRgb = tmp.imgRgb;
    
    % 3D: use the tight 3D box,
    BBTight = scaleBBstruct(allBb3dtight(i),[0.9,0.9,0.8]);
    BBTight = allBb3dtight(i);
    % find the major segments in the mask 
    isInBBIdx = ptsInTightBB(XYZworldframeTest,BBTight);
    numberOfptsInBB =sum(isInBBIdx);
    segInBB = segMask(isInBBIdx,:);
    uniqueLable = unique(segInBB(~isnan(segInBB)));  
    countLabel=histc(segInBB(~isnan(segInBB)),uniqueLable); 
    [countLabel,idx]=sort(countLabel,'descend');
    uniqueLable = uniqueLable(idx);

    % remove small segments and pick the top 2 segments 
    segWeight = countLabel/numberOfptsInBB;
    countLabel =countLabel(segWeight>majorSeg_Threshold&uniqueLable~=0);
    uniqueLable =uniqueLable(segWeight>majorSeg_Threshold&uniqueLable~=0);
    numOfSegConsider =min(numOfSegConsiderLimit,size(uniqueLable,1));
    if numOfSegConsider>0,
        countLabel =countLabel(1:numOfSegConsider);
        uniqueLable =uniqueLable(1:numOfSegConsider);
        segWeight = segWeight(1:numOfSegConsider);


        numofptsOnthisSeg = sum(bsxfun(@eq,segMask,uniqueLable(:)'),1)';
        inRatio =countLabel./numofptsOnthisSeg;
        outRatio =1-inRatio;
        accidental_getin_Idx =inRatio<accidentalGetin_Threshold;
        if length(inRatio)<2;
            inRatio = [inRatio,NaN];
        end
        scoreAll(i,:)= [inRatio(:)',nanmean(inRatio),sum(segWeight.*inRatio)/sum(segWeight)];   
    end
    %% 
    if i < numberOfexample&&genWeb
        randmap = [randperm(nanmax(refineMask(:))),0];
        refineMask_show = refineMask;
        refineMask_show(isnan(refineMask))=nanmax(refineMask(:))+1;

        maskedImg = drawBbOnImage(getImagesc(refineMask),allBb2dDraw(i,:),[1 1 0]);
        rgbImage = drawBbOnImage(double(imgRgb)/255,allBb2dDraw(i,:),[0 1 1]);
        imageMask = zeros(size(refineMask));
        try imageMask(refineMask ==uniqueLable(1)) =2;end
        try imageMask(refineMask ==uniqueLable(2)) =1;end
        try imageMask(refineMask(:) ==uniqueLable(1)&isInBBIdx) =3;end
        try imageMask(refineMask(:) ==uniqueLable(2)&isInBBIdx) =4;end

        [~,gtBb2dDraw] = projectStructBbsTo2d(BBTight,Rtilt);
        imageMaskImag = drawBbOnImage(getImagesc(imageMask),gtBb2dDraw,[0 1 1]);% draw detection BB
        % draw detection BB
        imwrite([maskedImg,rgbImage,imageMaskImag],[outputpath num2str(i) '.jpg'])
    end
end
    save([outputpath '/SegScoreAll.mat'],'scoreAll');
end


fprintf('start thresholding results use seg...\n')
apall =[];
cnfthres = -Inf;
if exist('thresall','var')&&numel(thresall)==1,
        bestthres = thresall;
        bestap = NaN;
else
    thresall = [0:0.02:0.6];
    bestap =0;
    for thresid = 1:size(thresall(:),1);
        thres = thresall(thresid);
        size(allBb3d)
        seg_remove  = scoreAll(:,1)<thres&allBb3d(:,7)>cnfthres;
        allBb3dtight_seg_pick = allBb3dtight;
        allBb3d_seg_pick = allBb3d;
        allBb3d_seg_pick(seg_remove,7) =allBb3d_seg_pick(seg_remove,7)-1;
        allTestImgIds_seg_pick =allTestImgIds;

        [apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurveTightBB(categName,allBb3d_seg_pick,allBb3dtight_seg_pick,allTestImgIds_seg_pick,groundTruthBbs,gtLabels~=1);
        apScore
        apall =[apall,apScore];
        if bestap<apScore  
            bestthres = thres;
            bestap = apScore;
            bestrecall = recall;
            bestprecision = precision;
        end
    end
    f = figure;
    plot(thresall,apall(:)','x-');
    hold on;
    plot(bestthres,bestap,'-rx');
    saveas(f,[outputpath '_allapthre.fig']);
    saveas(f,[outputpath '_allapthre.png']);
end



%%
if genWeb 
    htmlFullName = [outputpath '/amazing_viewer.html'];
    delete(htmlFullName);
    htmlFile = fopen(htmlFullName,'w');
    if htmlFile < 0, error('cannot create file %s.html',htmlFullName); end
    fprintf(htmlFile,'<html>\n <head> \n <title>3D Detection Viewer</title>\n');
    fprintf(htmlFile,'<script type="text/javascript" src="//datatables.net/release-datatables/media/js/jquery.js"></script>\n<script type="text/javascript" src="//datatables.net/release-datatables/media/js/jquery.dataTables.js"></script>\n');
    fprintf(htmlFile,'<script type="text/javascript"> $(document).ready(function() {$("#example").dataTable( {"aaSorting": [[ 1, "asc" ]],"iDisplayLength": 50});} );</script>\n'); 
    fprintf(htmlFile,'</head>\n <body>\n');
    fprintf(htmlFile,'<table id="example" cellpadding="2" cellspacing="2" border="1">\n');
    fprintf(htmlFile,'<thead>\n<tr><th>detection socre</th> <th>seg1 socre</th> <th>seg2 score</th> <th>averag</th> <th>weight sum</th> <th>Image Num</th> <th>image</th> </tr>\n</thead>\n');
    fprintf(htmlFile,'<tbody>\n');
    width =700;
    for i =1:numberOfexample
       path_to_image =[ num2str(i)];
       fprintf(htmlFile,'<tr>');
       fprintf(htmlFile,'<td>%.3f</td>',allBb3d(i,7));
       fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,1));
       fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,2));
       fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,3));
       fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,4));
       fprintf(htmlFile,'<td>%d</td>',allTestImgIds(i));
       fprintf(htmlFile,'<td><img src="%s" width="%d"></td>',[path_to_image '.jpg'],width);
       fprintf(htmlFile,'</tr>\n');
    end
    fprintf(htmlFile,'</tbody>\n</table>');
    fprintf(htmlFile,'</body>\n');
    fprintf(htmlFile,'</html>\n');
end
%}