trainMatname ='chair29-Jan-2014nofirst';
load(['/n/fs/modelnet/Output/DetectionMat/' trainMatname '_nms.mat'])
majorSeg_Threshold = 0.001;
numOfSegConsiderLimit =2;
accidentalGetin_Threshold =0.01;

outputpath = ['/n/fs/modelnet/post_segment/' trainMatname 'majorSegthr_' num2str(majorSeg_Threshold) '/'];
numberOfexample = 200;
try 
    load([outputpath '/SegScoreAll.mat'],'scoreAll');
catch
    mkdir(outputpath);   
    scoreAll =zeros(size(allBb3d,1),4);
    parfor i =1:numberOfexample
        display(i/size(allBb3d,1))
        imageNum =allTestImgIds(i);
        tmp = load(['/n/fs/modelnet/NYUdataSet/NYUdatafeatureNew/' 'feature_' num2str(imageNum) '.mat'],'XYZworldframeTest','SpaceTest','Rorg','Rtilt','imgDepth','imgRgb','rgbTest');
        XYZworldframeTest = tmp.XYZworldframeTest;
        Rtilt =tmp.Rtilt;
        imgDepth =tmp.imgDepth;
        imgRgb =tmp.imgRgb;
        % 3D: use the tight 3D box,
        BBTight = scaleBBstruct(allBb3dtight(i),0.85);

        % figure,vis_point_cloud(XYZworldframeTest,rgbTest,20,7000);   hold on;    
        % vis_point_cloud(XYZworldframeTest(refineMask(:) == 6,:),repmat([1,0,0],[sum(refineMask(:) == 6),1]),20,5000);    
        % vis_point_cloud(XYZworldframeTest(segMaskOrg(:) == 6,:),repmat([0,0,1],[sum(segMaskOrg(:) == 6),1]),20,5000);  
        % vis_cube(BBTight(1), 'r', 5);


        % match seg labels to XYZworldframeTest pts
        refineMasktmp= load(['/n/fs/modelnet/NYUdataSet/NYUsegmentation/seg_' num2str(imageNum)]);
        refineMask = refineMasktmp.refineMask;
        segMaskOrg = refineMask;
        segMask =refineMask(:);
        % find the major segments in the mask 
        isInBBIdx = ptsInTightBB(XYZworldframeTest,BBTight);
        numberOfptsInBB =sum(isInBBIdx);
        segInBB = segMask(isInBBIdx,:);
        uniqueLable = unique(segInBB(~isnan(segInBB)));  
        countLabel=histc(segInBB(~isnan(segInBB)),uniqueLable); 
        [countLabel,idx]=sort(countLabel,'descend');
        uniqueLable = uniqueLable(idx);

        % remove small segments and pick the top 2 segments 
        segWeight = countLabel/numberOfptsInBB;
        countLabel =countLabel(segWeight>majorSeg_Threshold);
        uniqueLable =uniqueLable(segWeight>majorSeg_Threshold);
        numOfSegConsider =min(numOfSegConsiderLimit,size(uniqueLable));
        if numOfSegConsider>0,
            countLabel =countLabel(1:numOfSegConsider);
            uniqueLable =uniqueLable(1:numOfSegConsider);
            segWeight = segWeight(1:numOfSegConsider);


            numofptsOnthisSeg = sum(bsxfun(@eq,segMask,uniqueLable(:)'),1)';
            inRatio =countLabel./numofptsOnthisSeg;
            outRatio =1-inRatio;
            accidental_getin_Idx =inRatio<accidentalGetin_Threshold;
            scorethis =zeros(1,2);
            for si =1:length(uniqueLable)
                scorethis(1,si) =  inRatio(si);
            end
            scorethis = [scorethis,nanmean(inRatio),sum(segWeight.*inRatio)/sum(segWeight)];
            scoreAll(i,:) = scorethis;
        end
        %% 
        if i < numberOfexample
        randmap = [randperm(nanmax(refineMask(:))),0];
        refineMask_show = refineMask;
        refineMask_show(isnan(refineMask))=nanmax(refineMask(:))+1;

        maskedImg = drawBbOnImage(getImagesc(randmap(refineMask_show)),allBb2dDraw(i,:),[1 1 0]);
        rgbImage = drawBbOnImage(double(imgRgb)/255,allBb2dDraw(i,:),[0 1 1]);
        imageMask = zeros(size(refineMask));
        try imageMask(refineMask ==uniqueLable(1)) =2;end
        try imageMask(refineMask ==uniqueLable(2)) =1;end
        try imageMask(refineMask(:) ==uniqueLable(1)&isInBBIdx) =3;end
        try imageMask(refineMask(:) ==uniqueLable(2)&isInBBIdx) =4;end

        [~,gtBb2dDraw] = projectStructBbsTo2d(BBTight,Rtilt);
        imageMaskImag = drawBbOnImage(getImagesc(imageMask),gtBb2dDraw,[0 1 1]);% draw detection BB
        % draw detection BB
        imwrite([maskedImg,rgbImage,imageMaskImag],[outputpath num2str(i) '.jpg'])
        % imshow([maskedImg,rgbImage,imageMaskImag]);
        % title(score);
        end
    end
    %%
    save([outputpath '/SegScoreAll.mat'],'scoreAll');
end
%}

load([outputpath '/SegScoreAll.mat'],'scoreAll');
load('idxToimageNum.mat');
testIdRange =idxToimageNum(1:501);
trainIdRange =idxToimageNum(501:1074);

categName ='chair';
ConstsDetection;
[~,classId] = ismember(categName,consts.classNames);

load('/n/fs//modelnet/NYUdataSet/NewGt/groundtruthBBYawNew.mat')
groundTruthBbs = groundtruthBBYawNew;
gtLabels = [groundtruthBBYawNew.label]';

isValidGt = ([groundTruthBbs.classId] == classId) & ismember([groundTruthBbs.imageNum],testIdRange);
groundTruthBbs = groundTruthBbs(isValidGt);
gtLabels =gtLabels(isValidGt);

[apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurveTightBB(categName,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,gtLabels~=1);
apScore
figure
plot(recall, precision, '.-'); hold on;
grid on; xlabel 'recall'; ylabel 'precision'; axis equal; axis([0,1,0,1]);
title(sprintf('original AP = %.3f',apScore))

trainingIDs =1:numberOfexample;
%{
%% random forest
ntree =100
x = [allBb2dDraw(trainingIDs,17), scoreAll(trainingIDs,4)];
y = double(~isFp(trainingIDs));
B = TreeBagger(ntree,x,y,'Method','regression');
save(['/n/fs/modelnet/Code/detector_change_feature/post_process/B' num2str(ntree)],'B');
allBb3dtight_seg_pick = allBb3dtight;
allBb3d_seg_pick = allBb3d;
allBb3d_seg_pick(:,7) = predict(B,[allBb3d(:,7),scoreAll(:,4)]);
allTestImgIds_seg_pick =allTestImgIds;
%}
beta =[1,0.42,1];
nL =200;
sigmoidfunction =@(x)beta(3)./(1+exp(-beta(1)*(x-beta(2))));
segScore = sigmoidfunction(scoreAll(1:nL,4));
x = [allBb2dDraw(1:nL,17),segScore];
y = ~isFp(1:nL);
notnanInd=~isnan(sum(x,2));
x=x(notnanInd,:);
y=y(notnanInd,:);
model = svmtrain(double(y), double(x), sprintf(['-b 0 -s 0 -t 0 ']));
w = model.sv_coef' * model.SVs
bias = -model.rho;
allBb3dtight_seg_pick = allBb3dtight;
allBb3d_seg_pick = allBb3d;
allBb3d_seg_pick(:,7) =[allBb3d(:,7),sigmoidfunction(scoreAll(:,4))]*w(:)+bias;
allTestImgIds_seg_pick =allTestImgIds;
size(allBb3d_seg_pick)
size(allTestImgIds_seg_pick)

apall =[];
for thres = 0.35:0.02:0.58;
seg_pick  = scoreAll(:,4)>thres;
allBb3dtight_seg_pick = allBb3dtight;
allBb3d_seg_pick = allBb3d;
allBb3d_seg_pick(seg_pick,7) =allBb3d_seg_pick(seg_pick,7)+1;
allTestImgIds_seg_pick =allTestImgIds;
%% new ap 
[apScore,precision,recall,isTp,~,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurveTightBB(categName,allBb3d_seg_pick,allBb3dtight_seg_pick,allTestImgIds_seg_pick,groundTruthBbs,gtLabels~=1);
apall =[apall apScore]
end
plot(0.35:0.02:0.58,apall); hold on;
plot(0.35:0.001:0.58,0.67,'-r')
figure,plot(allBb3d_seg_pick(:,7),'-r');hold on;plot(allBb3d(:,7),'-b')
figure,
plot(recall, precision, '.-'); hold on;
grid on; xlabel 'recall'; ylabel 'precision'; axis equal; axis([0,1,0,1]);
title(sprintf('Class: %s, AP = %.3f', categName,apScore));




    
%}
%{
%% svm 
nl =200;
beta1 = 0.5:0.5:12;
beta2 =0.34:0.02:0.55;
beta3 = 0.3:0.2:2.6;
apall = nan(length(beta1),length(beta2),length(beta3));
%% train svm 
for i = 1:length(beta1),
    for j = 1:length(beta2),
        for k = 1:length(beta3),
            beta =[beta1(i),beta2(i),beta3(i)]
            sigmoidfunction =@(x)beta(3)./(1+exp(-beta(1)*(x-beta(2))));

            segScore = sigmoidfunction(scoreAll(1:nL,4));
            x = [allBb2dDraw(1:nL,17),segScore];
            y = ~isFp(1:nL);
            notnanInd=~isnan(sum(x,2));
            x=x(notnanInd,:);
            y=y(notnanInd,:);
            model = svmtrain(double(y), x, sprintf(['-b 0 -s 0 -t 0 ']));
            w = model.sv_coef' * model.SVs;
            bias = -model.rho;
            allBb3dtight_seg_pick = allBb3dtight;
            allBb3d_seg_pick = allBb3d;
            allBb3d_seg_pick(:,7) =[allBb3d(:,7),sigmoidfunction(scoreAll(:,4))]*w(:)+bias;
            allTestImgIds_seg_pick =allTestImgIds;
            [apScore,precision,recall,isTp,~,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = computePRCurveTightBB(categName,allBb3d_seg_pick,allBb3dtight_seg_pick,allTestImgIds_seg_pick,groundTruthBbs,gtLabels~=1);

            apall(i,j,k) =apScore;
        end
    end
end
save('/n/fs/modelnet/Code/detector_change_feature/post_process/apall','apall');
%}


%{
figure,
subplot(1,2,1)
plot(allBb2dDraw(1:nL,17),'-r'),hold on;plot(segScore,'-b'); plot(cumsum(~isFp(1:nL))./cumsum(ones(size(isFp(1:nL)))),'g'); plot(allBb3d_seg_pick(1:nL,7),'-m')
legend({'det_score','seg score','presision','final score'});
subplot(1,2,2)
plot(recall, precision, '.-'); hold on;
grid on; xlabel 'recall'; ylabel 'precision'; axis equal; axis([0,1,0,1]);
title(sprintf('Class: %s, beta1 =%s AP = %.3f', categName,mat2str(beta),apScore));
%}





htmlFullName = [outputpath '/amazing_viewer.html'];
delete(htmlFullName);
htmlFile = fopen(htmlFullName,'w');
if htmlFile < 0, error('cannot create file %s.html',htmlFullName); end
fprintf(htmlFile,'<html>\n <head> \n <title>3D Detection Viewer</title>\n');
fprintf(htmlFile,'<script type="text/javascript" src="//datatables.net/release-datatables/media/js/jquery.js"></script>\n<script type="text/javascript" src="//datatables.net/release-datatables/media/js/jquery.dataTables.js"></script>\n');
fprintf(htmlFile,'<script type="text/javascript"> $(document).ready(function() {$("#example").dataTable( {"aaSorting": [[ 1, "asc" ]],"iDisplayLength": 50});} );</script>\n'); 
fprintf(htmlFile,'</head>\n <body>\n');
fprintf(htmlFile,'<table id="example" cellpadding="2" cellspacing="2" border="1">\n');
fprintf(htmlFile,'<thead>\n<tr><th>detection socre</th> <th>seg1 socre</th> <th>seg2 score</th> <th>averag</th> <th>weight sum</th> <th>image</th> </tr>\n</thead>\n');
fprintf(htmlFile,'<tbody>\n');
width =700;
for i =1:numberOfexample
   path_to_image =[ num2str(i)];
   fprintf(htmlFile,'<tr>');
   fprintf(htmlFile,'<td>%.3f</td>',allBb2dDraw(i,17));
   fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,1));
   fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,2));
   fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,3));
   fprintf(htmlFile,'<td>%.3f</td>',scoreAll(i,4));
   fprintf(htmlFile,'<td><img src="%s" width="%d"></td>',[path_to_image '.jpg'],width);
   fprintf(htmlFile,'</tr>\n');
end
fprintf(htmlFile,'</tbody>\n</table>');
fprintf(htmlFile,'</body>\n');
fprintf(htmlFile,'</html>\n');
%}