function [idxToimageNum] = split_trainingtestingSetGroup( classID )
orderfile = sprintf('./splitset/%03d.mat',classID);
if exist(orderfile,'file'),
   load(orderfile)
else
    % split : split group first same video only in test or training set 
    load('RMRC_videoId.mat');
    load('groundTruthBbsAll.mat')
    groundTruthBbs = groundTruthBbsAll;
    gtLabels = [groundTruthBbs.label]';
    BBidx = [groundTruthBbs.classId] ==classID;

    groupIDpos = unique(RMRC_videoId([groundTruthBbs(BBidx).imageNum]));
    allgroupID = [1:max(RMRC_videoId)];
    groupIDneg = allgroupID(~ismember(allgroupID,groupIDpos));

    % randomize group order
    groupIDpos =groupIDpos(randperm(length(groupIDpos)));
    groupIDneg =groupIDneg(randperm(length(groupIDneg)));

    % split group so that each set has similar number of images
    numberineachgroupPos = sum(bsxfun(@eq,RMRC_videoId',groupIDpos),1);
    [~,numposgroup] = min(abs(cumsum(numberineachgroupPos)-ceil(0.5*sum(numberineachgroupPos))));
    numberineachgroupNeg = sum(bsxfun(@eq,RMRC_videoId',groupIDneg),1);
    [~,numneggroup] = min(abs(cumsum(numberineachgroupNeg)-ceil(0.5*sum(numberineachgroupNeg))));


    trainingGroupIDs = [groupIDneg(1:numneggroup) groupIDpos(1:numposgroup)];
    testingGroupIDs  =[groupIDneg(numneggroup+1:end) groupIDpos(numposgroup+1:end)];

    allImageID = [1:max([groundTruthBbs.imageNum])];
    trainingImageIDs = allImageID(ismember(RMRC_videoId,trainingGroupIDs));
    testingImageIDs = allImageID(ismember(RMRC_videoId,testingGroupIDs));
    idxToimageNum = [trainingImageIDs testingImageIDs];
    lengthOftraining = length(trainingImageIDs);
    save(orderfile,'idxToimageNum','lengthOftraining')
end


%%
%{
videoname = cell(1449,1);
for i =1:length(rawRgbFilenames)

    ind =find(rawRgbFilenames{i}=='/');
    videoname(i) ={rawRgbFilenames{i}(1:ind-1)};
end

unique_videoname = unique(videoname,'stable');
[~,videoId] =ismember(videoname,unique_videoname);
load('matchTwodataset.mat');

RMRC_videoId =[];
for imageNum =1:length(matchTwodataset)
    RMRC_videoId(imageNum) = videoId(matchTwodataset(imageNum));
end
save('/n/fs/modelnet/Code/detector_change_feature/RMRC_videoId.mat','RMRC_videoId')
%}