function mesh2off(OFFfilename, faces,vertices,facecolor)
% output a mesh into an OFF file
% input:
% OFFfilename is the file name for the off file
%  vertices is Nx3  matrix for vertex index
%  faces is KxD matrix. D is the number of polygon size. =3 if triangles


file = fopen(OFFfilename,'w');
fprintf (file, 'OFF \n%d %d 0\n', size(vertices,1), size(faces,1));
for v=1:size(vertices,1)
    fprintf(file, '%f %f %f\n', vertices(v,1), vertices(v,2), vertices(v,3));
end

if min(faces(:)) ==1,
   faces = faces -1; % matlab starts from 1, office starts from 0
end

for f=1:size(faces,1)
    fprintf(file, '%d', size(faces,2));
    for i=1:size(faces,2)
        fprintf(file, ' %d', faces(f,i));
    end
    
    if exist('facecolor','var')&&~isempty(facecolor)
       for i=1:size(facecolor,2)
           fprintf(file, ' %d', facecolor(1,i)); 
       end
    end
    fprintf(file, '\n');
end

fclose(file);
end